<?php

function SaveLog($data)
{
	global $fp;
	
	return;
	
	$time = getdate();	
	$log = "[".$time['hours'].":".$time['minutes'].":".$time['seconds']."] - Executing FAILED:  ".$data."\n";		
	fputs($fp, $log);	
}

if($submitYes != "Continue")
{		
	header("Location: index.html");
	exit();
}

$systemTables = array('inl_ban_list', 'inl_cats', 'inl_config', 'inl_custom', 'inl_email', 'inl_fav', 'inl_keywords', 'inl_lc', 'inl_links', 'inl_rel_cats', 'inl_reviews', 'inl_search_log', 'inl_sessions', 'inl_users', 'inl_votes');

$include_path="../../includes";

// @set_time_limit(3600);
$max_execution_time = 50;

$configfile="$include_path/config.php";
$adodb_path="$include_path/adodb";

$fd = @fopen($configfile, "r");
$cfg = fread($fd, 8000);
@fclose($fd);
$sql_server_pos=strpos($cfg,"\$sql_server = \"")+strlen("\$sql_server = \"");
$sql_server = substr($cfg, $sql_server_pos, strpos($cfg,"\"",$sql_server_pos) - $sql_server_pos);

$sql_user_pos=strpos($cfg,"\$sql_user = \"")+strlen("\$sql_user = \"");
$sql_user = substr($cfg, $sql_user_pos, strpos($cfg,"\"",$sql_user_pos) - $sql_user_pos);

$sql_pass_pos=strpos($cfg,"\$sql_pass = \"")+strlen("\$sql_pass = \"");
$sql_pass = substr($cfg, $sql_pass_pos, strpos($cfg,"\"",$sql_pass_pos) - $sql_pass_pos);

$sql_db_pos=strpos($cfg,"\$sql_db = \"")+strlen("\$sql_db = \"");
$sql_db = substr($cfg, $sql_db_pos, strpos($cfg,"\"",$sql_db_pos) - $sql_db_pos);

$sql_type_pos=strpos($cfg,"\$sql_type = \"")+strlen("\$sql_type = \"");
$sql_type = substr($cfg, $sql_type_pos, strpos($cfg,"\"",$sql_type_pos) - $sql_type_pos);

include_once("$include_path/adodb/adodb.inc.php");

if (!$conn=&ADONewConnection($sql_type) || !$conn->Connect($sql_server, $sql_user, $sql_pass, $sql_db))
{	
	echo "Database Connection Failed!";
	exit();
}

if(!$file = @fopen("dump.php","r"))
{		
	echo "File dump.php could not be opened. Restoring Failed!";
	exit();
}
else
{	
	$rest = @fgets($file, 200000);	
	$rest = @fgets($file, 200000);
	
	if (is_null($_start_pos))
		$_local_data = md5($root_pass);
	else
	{
		$sql = "SELECT data FROM inl_restore_temp WHERE id='1'";
		if ($rs = &$conn->Execute($sql))
			$_local_data = $rs->fields['data'];		
	}

	if(ereg("###".$_local_data."###", $rest)!=1)
	{	
		echo "Root password does not match. Please try again.\n<a href=\"#\" onclick='history.back()'>Back</a>";
		exit();
	}
		
	if (is_null($_start_pos))
	{
		$listToDrop = implode(", ", $systemTables);
		if (strlen($listToDrop = eregi_replace(", $", "", $listToDrop)))
			$rs = &$conn->Execute("DROP TABLE ".$listToDrop);
			
		$rs = &$conn->Execute("DROP TABLE inl_restore_temp");
		
		if ($sql_type == "mysql")
			$idfield = "INT NOT NULL auto_increment";
		elseif ($sql_type == "postgres7")
			$idfield = "serial";
		elseif ($sql_type == "mssql")
			$idfield = "INT IDENTITY (1, 1) NOT NULL ";
		
		$sql = "CREATE TABLE inl_restore_temp (id $idfield, data TEXT, time INT DEFAULT '0' NOT NULL, PRIMARY KEY (id))";
		$rs = &$conn->Execute($sql);
		
		$_local_data = md5($root_pass);		
		
		$sql = "INSERT INTO inl_restore_temp (id, data, time) VALUES ('0', '$_local_data', '".time()."')";
		$rs = &$conn->Execute($sql);		
	}		
	
	if($sql_type == "postgres7")
	{
		$conn->Execute("DROP SEQUENCE inl_cats_cat_id_seq");
		$conn->Execute("DROP SEQUENCE inl_custom_cust_id_seq");
		$conn->Execute("DROP SEQUENCE inl_email_email_id_seq");
		$conn->Execute("DROP SEQUENCE inl_links_link_id_seq");
		$conn->Execute("DROP SEQUENCE inl_reviews_rev_id_seq");
		$conn->Execute("DROP SEQUENCE inl_search_log_log_id_seq");
		$conn->Execute("DROP SEQUENCE inl_sessions_ses_id_seq");
		$conn->Execute("DROP SEQUENCE inl_users_user_id_seq");
	}

	$failed = 0;
	
	if (!is_null($_start_pos))
	{
		fseek($file, $_start_pos);
		$restore_log = "a";
	}
	else
		$restore_log = "w";
		
	// $fp = @fopen("restore_log.php", $restore_log);
		
	$start_timer = time();	
	
	while((time() - $start_timer) < ($max_execution_time - 10))
	{					
		$rest = trim(@fgets($file, 200000));		
		
		if(!$rest || ($rest=="*/") || ($rest=="?>") || ($rest=="/*****In-link SQL dump*****/ /*") || ($rest=="header(\"Location: index.html\");"))
			continue;		
				
		if(substr($rest,-1,1) == ";")
			$rest = substr($rest,0,strlen($rest)-1);
				
		$rs = &$conn->Execute($rest);
		if(!$rs)
		{
			SaveLog($rest);
			$sql = "INSERT INTO inl_restore_temp (data, time) VALUES ('$rest', '".time()."')";
			$rs = &$conn->Execute($sql);	
		}
	
		if (feof($file))		
		{
			$finished = 1;
			break;	
		}
	}
	
	$_start_pos = ftell($file);
	
	if (!$finished)
	{
		$filesize = filesize("dump.php");
		## Count and draw per centage bar
		$PERCENT = 100*$_start_pos/$filesize;
		$PERCENT = number_format($PERCENT, 1);
		$t = 100 - $PERCENT;
		$p = $PERCENT;
		$t = number_format($t,0);
		$p = number_format($p,0);
			
		$check_processing = "<center>Restoring Process...</center>
		<div align=\"center\"><font color='#A0A0E0'><b>".$PERCENT."%</b></font></div>
	  		<table border='1' cellspacing='0' width='100%' bordercolor='#C0C0C0'>
	     	  <tr>
	      	    <td width='".$PERCENT."%' bgcolor='#A0A0E0'>&nbsp;</td>
	      	    <td width='".$t."%'>&nbsp;</td>
	      	  </tr>
	      	</table>";	
				
			$check_processing.= "
				<script language=\"javascript\">
				<!-- 			
					window.setTimeout('location.href=\"restore_db.php?submitYes=Continue&_start_pos=$_start_pos\"', 100);						
				//-->
				</script>";
		}
		else
		{
			$sql = "SELECT * FROM inl_restore_temp WHERE id!='1'";
			$rs = &$conn->Execute($sql);
			if ($rs && !$rs->EOF)
			{
				while ($rs && !$rs->EOF)
				{
					$failed.= "[".date("H:i:s", $rs->fields['time'])."] -> ".$rs->fields['data']." <B>[<FONT COLOR=\"red\">FAILED</FONT>]</B><BR>";
					$rs->MoveNext();
				}	
				
				if (strlen($failed))
					$check_processing = "<BR><BR><B>Database restored with Errors:</B><BR><BR>".$failed;						
			}
			else
			{
				$check_processing = "<BR><BR>Database successfully restored. Click <a href=\"../login.php\">here</a> to log in.";
			}
			$rs = &$conn->Execute("DROP TABLE inl_restore_temp");
		}
		## End Count and draw per centage bar
	
	fclose($file);
	// fclose($fp);

	$html1 = "<HTML><HEAD><TITLE></TITLE></HEAD><BODY>";
	$html2 = "</BODY></HTML>";
	echo $html1.$check_processing.$html2;	
}
?>
