<?php
/*
	In-link Functions Library Version 2.3.2
	Miscellaneous Functions
	Included in config.php, required for all scripts

	Last updated 11/10/03
*/


function print_links($query, $tpl, $lim=0, $start=0, $word="")
{	
	global $conn, $link_data, $toprate, $tophits, $link_pop, $lu_no_links, $la_no_links, $cat, $use_pick_tpl, $link_top, $admin, $ses, $multiple_search_instances, $link_data_CatsID, $ExcludedTemplates, $t, $extended_search, $SearchLogData, $picks_templ, $cachedData;
	
	// SET NO LINKS MESSAGE
    $l_no_links = $admin? $la_no_links : $lu_no_links;
    
    // SET SOME TEMPLATES
	$ExcludedTemplates	= array('index', 'sub_pages');
	$IncludedTemples	= array('list_duplicate_links', 'expr_links', 'validate_links', 'pend_links');
	$link_data_CatsID   = array();
	$prev_linkID = -1;
	$MoreThenOneLink = 0;
    
	// SET DEFAULT PICKS TEMPLATE
	if (!strlen($picks_templ))
        		$picks_templ = "list_pick_links";

	$query = ereg_replace("@\!", "&", $query);

	settype($lim,"integer");
	settype($start,"integer");
	
	if($lim)
		$rs = &$conn->SelectLimit($query, $lim, $start);
	else
		$rs = &$conn->Execute($query);
		
	// echo $query."-".$lim."-".$start."-";
		
	if ($rs && !$rs->EOF)
	{	
		do
		{	
			if (($tpl=="validate_links") && $ses["user_perm"]==5)
			{	//get cat info


				$lid = $rs->fields[0];
				$rs2 = &$conn->Execute("SELECT cat_user FROM inl_cats LEFT JOIN inl_lc ON inl_lc.cat_id=inl_cats.cat_id WHERE inl_lc.link_id=$lid");

				if ($rs2 && !$rs2->EOF)
				{	
					if($rs2->fields[0]==$ses["user_id"])
						$show=1;
					else
						$show=0;
				}
				else $show=0;
			}
			elseif ($tpl=="list_mod_links")
			{
				$lid=-$rs->fields[0];
				$rs2 = &$conn->Execute("SELECT link_id FROM inl_lc WHERE link_pend=$lid");

				if ($rs2 && !$rs2->EOF)
					$show=0;
				else
					$show=1;
			}
			else
				$show=1;
			
			
			if($show)
			{					
				// DIFFERENT HANDALING IN CASE IF ARE USING SEARCH or SOME OTHER FUNCTIONs 
				// AND WANT TO SHOW MULTIPLE CATEGORIES
				if (in_array($tpl, $IncludedTemples) || ($extended_search && $t && !in_array($t, $ExcludedTemplates) && (!$multiple_search_instances || ($admin && ($t == "pending_links"))) && ($SearchLogData['search_type'] == 1)))
				{
					if (($prev_linkID != $rs->fields["link_id"]) || ($prev_linkID == -1))
					{
					
						if ($prev_linkID != -1)
						{
							$link_data = $link_dataPrev;
							if ($use_pick_tpl && ($tpl=="list_links" || $tpl=="list_search_links") && ($link_data[2]=="1") && ($admin!=1)) //separate tpl for picked links
							{
								$ret.= parse($picks_templ);
							}
							else
							{
								$ret.= parse($tpl);
							}
							$link_data_CatsID = array();
						}
						$MoreThenOneLink = 1;
										
					}
					
					$prev_linkID = $rs->fields["link_id"];
					$link_data_CatsID[] = $rs->fields["cat_id"];
					$link_dataPrev = $rs->fields;
				} // END 				
				else
				{
					$link_data = $rs->fields;
					if($use_pick_tpl && ($tpl=="list_links" || $tpl=="list_search_links") && $link_data[2]=="1" && $admin!=1) //separate tpl for picked links
						$ret .= parse($picks_templ);
					else
						$ret .= parse($tpl);

				}
			}
			$rs->MoveNext();
		} 
		while ($rs && !$rs->EOF);

		// PRINT OUT LAST LINK
		if (($MoreThenOneLink == 1) && (in_array($tpl, $IncludedTemples) || ($extended_search && ($SearchLogData['search_type'] == 1))))
		{
			$link_data = $link_dataPrev;
		    if ($use_pick_tpl && ($tpl=="list_links" || $tpl=="list_search_links") && ($link_data[2]=="1") && ($admin!=1)) //separate tpl for picked links
				$ret.= parse("list_pick_links");
			else
				$ret.= parse($tpl);
		}
	}
	else //RETURN no links or error
		$ret = "<span class='sys-message'>$l_no_links</span>";

	return $ret;
}

function validatelink($cat_list) 
{
	global $form_input_add_link_name, $form_input_add_link_desc,  $form_input_add_link_url, $form_input_add_link_user, $form_input_add_link_votes, $form_input_add_link_hits, $form_input_add_link_rating, $form_input_add_link_cust1, $form_input_add_link_cust2, $form_input_add_link_cust3, $form_input_add_link_cust4, $form_input_add_link_cust5, $form_input_add_link_cust6, $admin,
	# CREATION DATE
	$form_input_add_link_month, $form_input_add_link_day, $form_input_add_link_year, $form_input_add_link_minute, $form_input_add_link_hour, $form_input_add_link_second,
	# MODIFICATION DATE 
	$form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year,
	$form_input_add_link_modified_minute,$form_input_add_link_modified_hour, $form_input_add_link_modified_second,	
	# EXPIRATION DATE 
	$form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year, $form_input_add_link_expires_minute,$form_input_add_link_expires_hour, $form_input_add_link_expires_second;

	$error = 0;
	$form_input_add_link_rating=$form_input_add_link_rating*1.0000;

	if (strlen($form_input_add_link_modified_month)<1)	$form_input_add_link_modified_month = 0;
	if (strlen($form_input_add_link_modified_year)<1)	$form_input_add_link_modified_year = 0;
	if (strlen($form_input_add_link_modified_day)<1)	$form_input_add_link_modified_day = 0;
	if (strlen($form_input_add_link_modified_hour)<1)	$form_input_add_link_modified_hour = 0;
	if (strlen($form_input_add_link_modified_second)<1) $form_input_add_link_modified_second = 0;
	if (strlen($form_input_add_link_modified_minute)<1) $form_input_add_link_modified_minute = 0;

	if (strlen($form_input_add_link_expires_month)<1)	$form_input_add_link_expires_month = 0;
	if (strlen($form_input_add_link_expires_year)<1)	$form_input_add_link_expires_year = 0;
	if (strlen($form_input_add_link_expires_day)<1)		$form_input_add_link_expires_day = 0;
	if (strlen($form_input_add_link_expires_hour)<1)	$form_input_add_link_expires_hour = 0;
	if (strlen($form_input_add_link_expires_second)<1)	$form_input_add_link_expires_second = 0;
	if (strlen($form_input_add_link_expires_minute)<1)	$form_input_add_link_expires_minute = 0;

	settype($form_input_add_link_modified_month, "integer");
	settype($form_input_add_link_modified_year, "integer");
	settype($form_input_add_link_modified_day, "integer");
	settype($form_input_add_link_modified_hour, "integer");
	settype($form_input_add_link_modified_second, "integer");
	settype($form_input_add_link_modified_minute, "integer");
	
	settype($form_input_add_link_expires_month, "integer");
	settype($form_input_add_link_expires_year, "integer");
	settype($form_input_add_link_expires_day, "integer");
	settype($form_input_add_link_expires_hour, "integer");
	settype($form_input_add_link_expires_second, "integer");
	settype($form_input_add_link_expires_minute, "integer");		

	settype($form_input_add_link_month, "integer");
	settype($form_input_add_link_year, "integer");
	settype($form_input_add_link_day, "integer");
	settype($form_input_add_link_hour, "integer");
	settype($form_input_add_link_second, "integer");
	settype($form_input_add_link_minute, "integer");

	settype($form_input_add_link_votes, "integer");
	settype($form_input_add_link_hits, "integer");
	settype($form_input_add_link_rating, "double");

	if ($form_input_add_link_name == "") {
		$error = 1;
	} elseif ((is_int($form_input_add_link_month) == false) || ($form_input_add_link_month > 12)) {
		$error = 3;
	} elseif ((is_int($form_input_add_link_day) == false) || ($form_input_add_link_day > 31)) {
		$error = 4;
	} elseif ((is_int($form_input_add_link_year) == false) || (strlen($form_input_add_link_year) != 4)) {
		$error = 5;
	} elseif (is_int($form_input_add_link_votes) == 0) {
		$error = 7;
	} elseif (is_int($form_input_add_link_hits) == 0) {
		$error = 8;
	} elseif ((is_double($form_input_add_link_rating) == false) || ($form_input_add_link_rating > 5) || ($form_input_add_link_rating < 0)) {
		$error = 9;
	} 
	elseif($admin==1)
	{
		if(!$form_input_add_link_user)
			$error=11;
	}

	if ($form_input_add_link_modified_month > 12)
		$error = 12;
	if ($form_input_add_link_modified_day > 31)
		$error = 13;
	if (($form_input_add_link_modified_year!=0) && (strlen($form_input_add_link_modified_year) != 4))
		$error = 14;

	if ($form_input_add_link_expires_month > 12)
		$error = 15;
	if ($form_input_add_link_expires_day > 31)
		$error = 16;
	if (($form_input_add_link_expires_year!=0) && (strlen($form_input_add_link_expires_year) != 4))
		$error = 17;

	$cats=split(",",$cat_list);
	reset($cats);
	$cat_found="";
	while (list ($key, $value) = each($cats)) 
		if($value)
			$cat_found="1";
	if(!$cat_found)
		$error=10;
	
	$form_input_add_link_name = inl_escape($form_input_add_link_name);
	$form_input_add_link_url  = inl_escape($form_input_add_link_url);
	$form_input_add_link_desc = inl_escape($form_input_add_link_desc);
	$form_input_add_link_image= inl_escape($form_input_add_link_image);
	$form_input_add_link_cust1 = inl_escape($form_input_add_link_cust1);
	$form_input_add_link_cust2 = inl_escape($form_input_add_link_cust2);
	$form_input_add_link_cust3 = inl_escape($form_input_add_link_cust3);
	$form_input_add_link_cust4 = inl_escape($form_input_add_link_cust4);
	$form_input_add_link_cust5 = inl_escape($form_input_add_link_cust5);
	$form_input_add_link_cust6 = inl_escape($form_input_add_link_cust6);

	// CHECK FOR BAN
	if (($admin != 1) && strlen($form_input_add_link_url)>0)
	{
		if (!$_banned = ban_check($form_input_add_link_url, 3))
			$error = "banned_link_url";		
	}
	

	return $error;
}

## Modified in In-link 2.3.3
function delete_link($link_id, $link_cat = null)
{	
	//delete from lc, just the instance
	global $conn, $ses, $having, $extended_search, $sid;

	if(ereg("pending_links",$ses["destin"])>0)
	{
		global $email_perm, $subject, $from, $reply, $user_data, $email_link, $lib_included;
		
		if($email_perm[10]==1)
		{
			$query = "SELECT * FROM inl_links where link_id=$link_id";
			$rs = &$conn->Execute($query);
			$email_link = $rs->fields;
			$query="select * from inl_users where user_id=".$email_link["link_user"];
			$rs = &$conn->Execute("$query"); 
			$user_data = $rs->fields;
			if($lib_included!=1)
			{
				include("../includes/admin_email_lib.php");
				$lib_included=1;
			}

			$body = email_parse("mail_user_link_denied");
			if($user_data["email"])
				@mail($user_data["email"], $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
		}		
	}
	## delete category link relation for specified category OR all in NULL or ALL
	$add_catID = (($link_cat == "all") || is_null($link_cat))? "" : " AND cat_id='$link_cat'";
	$conn->Execute("DELETE FROM inl_lc where link_id='$link_id'".$add_catID);
	$conn->Execute("DELETE FROM inl_fav where link_id='$link_id'");
	
	## Delete this link from search results as well
	if ($having && $extended_search)
	{
		$conn->Execute("DELETE FROM inl_".$sid." where link_id='$link_id' AND cat_id='$link_cat'");		
	}
	
	## Added in In-link 2.3.3
	## Remove link from validation table
	quarantine_functions("unqaurantine", $link_id);
	## End Added
	
	$rs = &$conn->Execute("select count(link_id) from inl_lc where link_id=$link_id");
	$count = ($rs->EOF)? 1 : $rs->fields[0];	

	if(($link_cat=="all") || ($count == 0))
	{	//take care of custom, if any
		$rs = &$conn->Execute("select link_cust from inl_links where link_id='$link_id'");
		if ($rs && !$rs->EOF)
		{
			if ($rs->fields[0])
			{
				$conn->Execute("DELETE FROM inl_custom where cust_id='".$rs->fields[0]."'");
			}
		}

		//delete physical link record itself
		$conn->Execute("DELETE FROM inl_links where link_id='$link_id'");
		
		//clean up references (should already be Ok);
		$conn->Execute("DELETE FROM inl_lc where link_id=$link_id");

		$conn->Execute("DELETE FROM inl_reviews where rev_link=$link_id");
		
		// DELETE SEARCH TABLE
		if ($having && $extended_search)
		{
		  $conn->Execute("DELETE FROM inl_".$sid." where link_id='$link_id'"); 		
		}		
	}
	
	$ret = ($link_cat=="all")? update_all_link_count() : update_link_count($link_cat);
}
## End Modified

function moves_link($link_id, $cat_to, $cat_from)
{	global $conn;
	if($cat_from=="all")
	{	//clean up references
		$query="delete from inl_lc where link_id=$link_id";
		$conn->Execute($query);
		//re-create reference for the new cat
		$query="INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ('$link_id','$cat_to','0')";
		$conn->Execute($query);
		update_all_link_count();
	}
	else
	{	//update only current reference
		settype($cat_from,"integer");
		$query="UPDATE inl_lc SET cat_id='$cat_to' WHERE link_id='$link_id' and cat_id='$cat_from'";
		$conn->Execute($query);
		update_link_count($cat_to);
		update_link_count($cat_from);
	}
}

function gotolink($id)
{	
    global $conn, $admin_redir, $sid, $session_get, $REMOTE_ADDR;
	
    // PREVENT MULTIPLE COUNTS FROM SAME IP
    $expired = time()-259200;
	$query="DELETE FROM inl_votes WHERE stamp<'$expired' AND rev='3' AND vote_link='$id'";
	$rs = &$conn->Execute($query);
	
	$query = "SELECT stamp FROM inl_votes WHERE vote_ip='".$REMOTE_ADDR."' AND rev='3' AND vote_link='$id'";
	$rs = &$conn->Execute($query);
	$count_hit = ($rs && !$rs->EOF)? false : true;	
	// END
	   
    $ret[0] = false;
    $att_sid = ($sid && $session_get)? "sid=$sid&" : "";

	$query = $admin_redir? "SELECT link_url FROM inl_links WHERE link_id='$id'" : "SELECT link_url FROM inl_links WHERE link_id='$id' AND link_vis='1'";
		

	$rs = &$conn->Execute($query);
	if ($rs && !$rs->EOF)
	{	
	    $url = $rs->fields[0];
		if ($count_hit)
		{
	       $query = "UPDATE inl_links SET link_hits=link_hits+1 WHERE link_id='$id'";
		   $rs = &$conn->Execute($query);
		   
		   ## Added in In-link 2.3.3
		   # Increase link hits counter by one.
		   updateTotalLinkHitsSum("+1");
		   # Update/recalculate Max Rating and Hits
		   updateTopLinkValues();
		   ## End
		   
		   $query="INSERT INTO inl_votes VALUES ('".time()."','".$REMOTE_ADDR."', '$id', 3)";
		   $rs = &$conn->Execute($query);
		}
		$ret[0] = true;
		$ret[1] = $url;
	}
	elseif($admin_redir)
	   $ret[1] = "navigate.php?$att_sid";
	else
	   $ret[1] = "index.php?$att_sid";
		
    return $ret;
}

## Modified in In-link 2.3.3
function get_top_links()
{		
    global $conn, $link_top, $admin;

	$vis = $admin? "" : "AND link_vis=1 ";	
	$query = " WHERE link_pend!=1"; 
	
	$rs = &$conn->SelectLimit("SELECT inl_lc.link_id FROM inl_links LEFT JOIN inl_lc ON inl_lc.link_id = inl_links.link_id WHERE inl_lc.link_pend=0 $vis GROUP BY inl_lc.link_id ORDER BY inl_links.link_rating DESC", $link_top, 0);	
		
	if ($rs && !$rs->EOF) 
	{	
		$query.= " AND inl_lc.link_id IN (";
		while (!$rs->EOF) 
		{	
			$IDs.= $rs->fields['link_id'].", "; 			
			$rs->MoveNext();			
		}
		
		$IDs = strlen($IDs)? ereg_replace(", $", "", $IDs) : -1;
		$ret = $query.$IDs.") ".$vis;
	}

	return $ret;
}	

## Modified in In-link 2.3.3
function get_pop_links()
{
	global $conn, $link_pop, $admin, $sql_type;

	$vis = $admin? "" : "AND link_vis=1 ";	
	$query = " WHERE link_pend!=1"; 

	if ($sql_type == "mssql")
		$_add_sql = " GROUP BY inl_links.link_hits";
		
	$rs = &$conn->SelectLimit("SELECT DISTINCT inl_lc.link_id FROM inl_links LEFT JOIN inl_lc ON inl_lc.link_id = inl_links.link_id WHERE inl_lc.link_pend=0 $vis$_add_sql ORDER BY inl_links.link_hits DESC", $link_pop, 0);
	
	if ($rs && !$rs->EOF) 
	{	
		$query.= " AND inl_lc.link_id IN (";
		while (!$rs->EOF) 
		{	
			$IDs.= $rs->fields['link_id'].", "; 			
			$rs->MoveNext();			
		}
		
		$IDs = strlen($IDs)? ereg_replace(", $", "", $IDs) : -1;
		$ret = $query.$IDs.") ".$vis;
	}
	
	return $ret;	
}
## End Modified

function get_new_links()
{
	global $link_new, $admin;
	
	$cutoffdate = mktime(0,0,0,date("m"),date("d")-$link_new,date("Y"));	
	$vis = $admin? "" : "AND link_vis=1 ";			
	$ret = " WHERE link_pend='0' $vis and link_date>='$cutoffdate'"; 
	
	return $ret;
}

function get_pick_links()
{	
    global $admin;
	
    $vis = !$admin? "AND link_vis=1 " : "";	
	$ret = " WHERE link_pend=0 $vis and link_pick=1"; 
	
	return $ret;
}

function get_user_links()
{	
	global $ses, $admin;
	
	$vis = $admin? "" : "AND link_vis=1 ";	

	if($ses["user_id"]<1) //no user
		$ret = " WHERE inl_lc.link_pend=0 $vis AND link_user='-1'";
	else
		$ret = " WHERE inl_lc.link_pend=0 $vis AND link_user='".$ses["user_id"]."'"; 
		
	return $ret;
}

## Modified in In-link 2.3.3
function get_fav_links()
{	
	global $ses;
	
	$ret = " WHERE inl_fav.user_id='".$ses["user_id"]."' AND inl_fav.link_id=inl_links.link_id ";
	 
	return $ret;
}
## End Modified

function add_new_link ($cat_list, $old_id=false) 
{	
	global $conn, $form_input_add_link_name, $form_input_add_link_desc, $month, $day, $year, $minute, $hour, $second, $form_input_add_link_url, $form_input_add_link_cust1, $form_input_add_link_cust2, $form_input_add_link_cust3, $form_input_add_link_cust4, $form_input_add_link_cust5, $form_input_add_link_cust6, $form_input_add_link_image, $perm_addlink, $ses, $rootperm,$cat, $start,$lu_error_addlink_not_allowed,$lu_error_db,$la_error_db, $admin, $form_input_add_link_vis, $form_input_add_link_pick, $form_input_add_link_hits, $form_input_add_link_votes, $form_input_add_link_rating, $form_input_add_link_month, $form_input_add_link_day, $form_input_add_link_year, $form_input_add_link_minute, $form_input_add_link_hour, $form_input_add_link_second, $attach, $having, $form_input_add_link_user, $lu_confirm_addlink, $lu_confirm_linkupdate, $old_link, $sql_type, $approved_link_expires, $direct_link_expires,
	# MODIFICATION DATE 
	$form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year,
	$form_input_add_link_modified_minute,$form_input_add_link_modified_hour, $form_input_add_link_modified_second,
	# EXPIRATION DATE 
	$form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year, $form_input_add_link_expires_minute, $form_input_add_link_expires_hour, $form_input_add_link_expires_second, $attach;
	
	if($admin==1)
	{	
		$l_error_db=$la_error_db;
		$templ_exec="navigate.php";
		if($form_input_add_link_pick=="on")
			$form_input_add_link_pick=1;
		else
			$form_input_add_link_pick=0;

		if($form_input_add_link_vis=="on")
			$form_input_add_link_vis=1;
		else
			$form_input_add_link_vis=0;
	}
	else
	{	
	    //set default settings for the user side
		if(!$form_input_add_link_day)
			$form_input_add_link_day=$day;
		if(!$form_input_add_link_month)
			$form_input_add_link_month=$month;
		if(!$form_input_add_link_year)
			$form_input_add_link_year=$year;
    	if (!$form_input_add_link_minute)
		    $form_input_add_link_minute = $minute;
		if (!$form_input_add_link_hour)
		    $form_input_add_link_hour = $hour;
		if (!$form_input_add_link_second)
		    $form_input_add_link_second = $second;
			
		$form_input_add_link_vis = 1;
		$form_input_add_link_pick=0;
		$form_input_add_link_hits=0;
		$form_input_add_link_votes=0;
		$form_input_add_link_rating=0;
		$form_input_add_link_user=$ses["user_id"];
		$templ_exec="index.php";
		$l_error_db=$lu_error_db;
	}
	
	
	$form_input_add_link_name = inl_escape($form_input_add_link_name);
	$form_input_add_link_url  = inl_escape($form_input_add_link_url);
	$form_input_add_link_desc = inl_escape($form_input_add_link_desc);
	$form_input_add_link_image= inl_escape($form_input_add_link_image);
	
	if (($form_input_add_link_cust1) || ($form_input_add_link_cust2) || ($form_input_add_link_cust3) || ($form_input_add_link_cust4) || ($form_input_add_link_cust5) || ($form_input_add_link_cust6))
	{	$form_input_add_link_cust1 = inl_escape($form_input_add_link_cust1);
		$form_input_add_link_cust2 = inl_escape($form_input_add_link_cust2);
		$form_input_add_link_cust3 = inl_escape($form_input_add_link_cust3);
		$form_input_add_link_cust4 = inl_escape($form_input_add_link_cust4);
		$form_input_add_link_cust5 = inl_escape($form_input_add_link_cust5);
		$form_input_add_link_cust6 = inl_escape($form_input_add_link_cust6);

		$query="insert into inl_custom (cust1, cust2, cust3, cust4, cust5, cust6) values ('$form_input_add_link_cust1', '$form_input_add_link_cust2', '$form_input_add_link_cust3', '$form_input_add_link_cust4', '$form_input_add_link_cust5', '$form_input_add_link_cust6')";
		$rs=&$conn->Execute($query);
		if($rs)
			$link_cust = $conn->Insert_ID("inl_custom","cust_id");
		else
			$link_cust=0;
	}

	$form_input_add_link_date = mktime($form_input_add_link_hour, $form_input_add_link_minute, $form_input_add_link_second, $form_input_add_link_month,$form_input_add_link_day,$form_input_add_link_year);

	if($old_id)
	{
		$rs=&$conn->Execute("SELECT * FROM inl_links WHERE link_id='$old_id'");
		$old_link = $rs->fields;
		$form_input_add_link_hits = $rs->fields["link_hits"];
		$form_input_add_link_votes=$rs->fields["link_votes"];
		$form_input_add_link_rating=$rs->fields["link_rating"];
		$form_input_add_link_pick=$rs->fields["link_pick"];
		$link_numrevs = $rs->fields["link_numrevs"];
		$form_input_add_link_date = $rs->fields["link_date"];
		$form_input_add_link_expires_date = $rs->fields["link_expires"];
		$form_input_add_link_modified_date = time();
	}
	else
	{
		
		if ($admin)
		{
			# CALCULATE THE MODIFICATION DATE
			$form_input_add_link_modified_date = 0;
		
			if ($GetSumModifiedDate = $form_input_add_link_modified_hour + $form_input_add_link_modified_minute + $form_input_add_link_modified_second + $form_input_add_link_modified_month + $form_input_add_link_modified_day + $form_input_add_link_modified_year)
			{
				$form_input_add_link_modified_date = mktime($form_input_add_link_modified_hour, $form_input_add_link_modified_minute, $form_input_add_link_modified_second, $form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year);
			}
			# END
		
			# CALCULATE THE EXPIRATION DATE
			$form_input_add_link_expires_date = 0;
			
			if ($GetSumExpiresDate = $form_input_add_link_expires_hour + $form_input_add_link_expires_minute + $form_input_add_link_expires_second + $form_input_add_link_expires_month + $form_input_add_link_expires_day + $form_input_add_link_expires_year)
			{
				$form_input_add_link_expires_date = mktime($form_input_add_link_expires_hour, $form_input_add_link_expires_minute, $form_input_add_link_expires_second, $form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year);
			}
			# END					
		}
	}
	
	if ($sql_type == "postgres7")
	{
		if (!isset($form_input_add_link_hits)) 
			$form_input_add_link_hits = 0;
		if (!isset($form_input_add_link_votes)) 
			$form_input_add_link_votes = 0;
		if (!isset($form_input_add_link_rating)) 
			$form_input_add_link_rating = 0;
		if (!isset($form_input_add_link_pick)) 
			$form_input_add_link_pick = 0;
		if (!isset($link_numrevs)) 
			$link_numrevs = 0;
		if (!isset($link_cust)) 
			$link_cust = 0;
	}
	
	if($old_id)
	{
		$link_pending_yes = -$old_id;
		$link_pending_no  = -$old_id;

		$query = "INSERT INTO inl_links (link_name, link_url, link_desc, link_date, link_vis, link_image, link_cust, link_user, link_pick, link_hits, link_votes, link_rating,link_numrevs, link_expires, link_modified) VALUES ('$form_input_add_link_name', '$form_input_add_link_url', '$form_input_add_link_desc', '$form_input_add_link_date', '$form_input_add_link_vis', '$form_input_add_link_image', '$link_cust', '$form_input_add_link_user', '$form_input_add_link_pick', '$form_input_add_link_hits', '$form_input_add_link_votes', '$form_input_add_link_rating','$link_numrevs', '$form_input_add_link_expires_date', '$form_input_add_link_modified_date')";
	}
	else
	{
		$link_pending_yes = 1;
		$link_pending_no  = 0;

		$query = "INSERT INTO inl_links (link_name, link_url, link_desc, link_date, link_vis, link_image, link_cust, link_user, link_pick, link_hits, link_votes, link_rating, link_numrevs, link_expires, link_modified) VALUES ('$form_input_add_link_name', '$form_input_add_link_url', '$form_input_add_link_desc', '$form_input_add_link_date', '$form_input_add_link_vis', '$form_input_add_link_image', '$link_cust', '$form_input_add_link_user', '$form_input_add_link_pick', '$form_input_add_link_hits', '$form_input_add_link_votes', '$form_input_add_link_rating','$link_numrevs', '$form_input_add_link_expires_date', '$form_input_add_link_modified_date')";
	}

	$rs = &$conn->Execute($query);
	$link_id = $conn->Insert_ID("inl_links","link_id");

	## Added in In-link 2.3.3
	# Update cached links counter
	if ($link_id && !$old_id)
		updateTotalCounters("links", +1);
	## 
	
	//begin inserting cat entries
	$cats=split(",",$cat_list);
	reset($cats);

	$SelectDirectExpirationPeriod = 0;

	while (list ($key, $value) = each($cats)) //avoiding holes in the list
	{	
		if($value && $value!="Home")
		{	//get cat information
			$query="select cat_perm from inl_cats where cat_id=$value";

			$rs = &$conn->Execute($query);

			if($rs && !$rs->EOF)
			{	
				if(check_perm($rs->fields[0],"link")==1 && $admin!=1) //pending
				{	
					//insert link
					$sql = "insert into inl_lc (link_id, cat_id, link_pend) values ($link_id, $value, $link_pending_yes)";
					if(!$rs = &$conn->Execute($sql))
						return "$templ_exec?t=error&message=".base64_encode("$l_error_db 2".$conn->ErrorMsg());
				}
				elseif(check_perm($rs->fields[0],"link")==2 && $admin!=1) //direct
				{	
					$SelectDirectExpirationPeriod = 1;
					if(!$conn->Execute("insert into inl_lc (link_id, cat_id, link_pend) values ($link_id, $value, $link_pending_no)"))
						return "$templ_exec?t=error&message=".base64_encode("$l_error_db 3".$conn->ErrorMsg());
				}
				elseif($admin==1)  //admin overrides
				{
					if(!$conn->Execute("insert into inl_lc (link_id, cat_id, link_pend) values ($link_id, $value, 0)"))
						return "$templ_exec?t=error&message=".base64_encode("$l_error_db 4".$conn->ErrorMsg());
				}
				else
				{
					$conn->Execute("DELETE FROM inl_links where link_id='$link_id'");
					$conn->Execute("DELETE FROM inl_custom where cust_id='$link_cust'");
					$msg=base64_encode($lu_error_addlink_not_allowed);
					return "index.php?$att_sid"."t=error&message=$msg";
				}
				update_link_count($value);
			}
			else
				return "$templ_exec?t=error&message=".base64_encode("$l_error_db 5".$conn->ErrorMsg());
				//else cat info not retrieved
		}
		elseif($value=="Home")
		{	if(check_perm(-1,"link") && $admin!=1) //pending
			{	//insert link
				if(!$conn->Execute("insert into inl_lc (link_id, cat_id, link_pend) values ($link_id,0,$link_pending_yes)"))
					return "$templ_exec?t=error&message=".base64_encode("$l_error_db 6".$conn->ErrorMsg());
			}
			elseif(check_perm(-1,"link")==2 && $admin!=1) //direct
			{	
				$SelectDirectExpirationPeriod = 1;
				if(!$conn->Execute("insert into inl_lc (link_id, cat_id, link_pend) values ($link_id,$value,$link_pending_no)"))
					return "$templ_exec?t=error&message=".base64_encode("$l_error_db 7".$conn->ErrorMsg());
			}
			elseif($admin==1) //admin overrides
				if(!$conn->Execute("insert into inl_lc (link_id, cat_id, link_pend) values ($link_id,0,0)"))
					return "$templ_exec?t=error&message=".base64_encode("$l_error_db 8".$conn->ErrorMsg());
		}
	}

	// SET LINK EXPIRATION FOR LINK DIRECTLY ADDED TO DB
	if (!$old_id && ($admin != 1) && ($SelectDirectExpirationPeriod == 1) && ($direct_link_expires>0))
	{
		$EpirationTime = time()+($direct_link_expires*86400);
		$sql = "UPDATE inl_links SET link_expires='".$EpirationTime."' WHERE link_id='".$link_id."'";
		$rs = &$conn->Execute($sql);
	}
	
	if($admin!=1)
	{
		global $email_perm, $subject, $from, $reply, $user_data, $email_link;
		$query="select * from inl_links where link_id=$link_id";
		$rs = &$conn->Execute("$query");
		$email_link = $rs->fields;
		include("includes/admin_email_lib.php");
		$query="select first,last,email,user_name from inl_users where user_id=".$email_link[5];
		$rs = &$conn->Execute("$query");
		$user_data = $rs->fields;
	}

	if($email_perm[1]==1 && $admin!=1)
	{
		if ( !$old_id ) $mail_body = "mail_admin_new_link"; else $mail_body = "mail_admin_mod_link";
		$body = email_parse($mail_body);
		if($u = get_admin_emails())
		{			
			@mail($u, $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
		}
	}
	if($email_perm[8]==1 && $admin!=1)
	{
		if ( !$old_id ) $mail_body = "mail_user_new_link"; else $mail_body = "mail_user_mod_link";
		$body = email_parse($mail_body);
		if($user_data["email"])
		{
			@mail($user_data["email"], $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
		}
	}
	
	/*
	if($email_perm[1]==1 && $admin!=1)
	{
		$body=email_parse("mail_admin_new_link");
		if($u=get_admin_emails())
			@mail($u, $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
	}
	if($email_perm[8]==1 && $admin!=1){
		$body=email_parse("mail_user_new_link");
		if($user_data[0])
			@mail($user_data[0], $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
	}
	*/
	//end inserting cat entries
	
	if ($admin==1)
	{
		$ret = $templ_exec."?".$ses["destin"]."&having=$having";
	}
	else
	{	
		$txt = !$old_id? $lu_confirm_addlink : $lu_confirm_linkupdate;
		$message = base64_encode($txt);		
				
		$ret = $templ_exec."?attach=$attach&having=$having&t=confirm&message=$message";
	}
	
	return $ret;
}

function save_link($id, $cat_list) 
{	
	global $conn, $form_input_add_link_name, $form_input_add_link_desc, $month, $day, $year, $form_input_add_link_url, $form_input_add_link_cust1, $form_input_add_link_cust2, $form_input_add_link_cust3, $form_input_add_link_cust4, $form_input_add_link_cust5, $form_input_add_link_cust6, $form_input_add_link_image, $perm_addlink, $ses, $rootperm,$cat, $start,$lu_error_addlink_not_allowed,$lu_error_db,$la_error_db, $admin, $form_input_add_link_vis, $form_input_add_link_pick, $form_input_add_link_hits, $form_input_add_link_votes, $form_input_add_link_rating, $form_input_add_link_month, $form_input_add_link_day, $form_input_add_link_year,$form_input_add_link_minute,$form_input_add_link_hour, $form_input_add_link_second, $attach, $having, $old_email, $email_link, $old_link, $form_input_add_link_user, $lu_confirm_linkupdate,
	# MODIFICATION DATE 
	$form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year,
	$form_input_add_link_modified_minute,$form_input_add_link_modified_hour, $form_input_add_link_modified_second,
	# EXPIRATION DATE 
	$form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year, $form_input_add_link_expires_minute,$form_input_add_link_expires_hour, $form_input_add_link_expires_second, $attach;
	

	$query="select * from inl_links where link_id=$id";
	$rs = &$conn->Execute($query);
	$old_link = $rs->fields;

	if($admin==1)
	{	$l_error_db="message=".base64_encode($la_error_db);
		if($attach=="duplicates")
			$templ_exec="duplicatelinks.php";
		else
			$templ_exec="navigate.php";
	}
	else
	{	$templ_exec="index.php";
		$l_error_db="message=".base64_encode($lu_error_db);
	}

	$rs = &$conn->Execute("select link_user, link_cust from inl_links where link_id=$id");
	if($rs && !$rs->EOF)
		$link_data = $rs->fields;
	else
		return "$templ_exec?t=error&$l_error_db";

	if($admin==1)
	{	if($form_input_add_link_pick=="on")
			$form_input_add_link_pick=1;
		else
			$form_input_add_link_pick=0;
		if($form_input_add_link_vis=="on")
			$form_input_add_link_vis=1;
		else
			$form_input_add_link_vis=0;

		$form_input_add_link_date = mktime($form_input_add_link_hour,$form_input_add_link_minute,$form_input_add_link_second,$form_input_add_link_month,$form_input_add_link_day,$form_input_add_link_year);
		
		# CALCULATE THE MODIFICATION DATE
		$form_input_add_link_modified_date = 0;

		if ($GetSumModifiedDate = $form_input_add_link_modified_hour + $form_input_add_link_modified_minute + $form_input_add_link_modified_second + $form_input_add_link_modified_month + $form_input_add_link_modified_day + $form_input_add_link_modified_year)
		{
			$form_input_add_link_modified_date = mktime($form_input_add_link_modified_hour, $form_input_add_link_modified_minute, $form_input_add_link_modified_second, $form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year);
		}
		# END

		# CALCULATE THE EXPIRATION DATE
		$form_input_add_link_expires_date = 0;
	
		if ($GetSumExpiresDate = $form_input_add_link_expires_hour + $form_input_add_link_expires_minute + $form_input_add_link_expires_second + $form_input_add_link_expires_month + $form_input_add_link_expires_day + $form_input_add_link_expires_year)
		{
			$form_input_add_link_expires_date = mktime($form_input_add_link_expires_hour, $form_input_add_link_expires_minute, $form_input_add_link_expires_second, $form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year);
		}
		# END
	}
	else
	{	if($ses["user_id"]<1)
			return "index.php?t=login&attach=$attach&having=$having";
		elseif($ses["user_id"]!=$link_data[0])
		{	$message=base64_encode($lu_error_wrong_user);
			return "index.php?t=error&message=$message";
		}
	}
		
	$form_input_add_link_name = inl_escape($form_input_add_link_name);
	$form_input_add_link_url  = inl_escape($form_input_add_link_url);
	$form_input_add_link_desc = inl_escape($form_input_add_link_desc);
	$form_input_add_link_image= inl_escape($form_input_add_link_image);
	
	if ($form_input_add_link_cust1 || $form_input_add_link_cust2 || $form_input_add_link_cust3 || $form_input_add_link_cust4 || $form_input_add_link_cust5 || $form_input_add_link_cust6)
	{	$form_input_add_link_cust1 = inl_escape($form_input_add_link_cust1);
		$form_input_add_link_cust2 = inl_escape($form_input_add_link_cust2);
		$form_input_add_link_cust3 = inl_escape($form_input_add_link_cust3);
		$form_input_add_link_cust4 = inl_escape($form_input_add_link_cust4);
		$form_input_add_link_cust5 = inl_escape($form_input_add_link_cust5);
		$form_input_add_link_cust6 = inl_escape($form_input_add_link_cust6);

		if(!$link_data[1]) //custom fields do not yet exist
		{	
			$query="INSERT into inl_custom (cust1, cust2, cust3, cust4, cust5, cust6) values ('$form_input_add_link_cust1', '$form_input_add_link_cust2', '$form_input_add_link_cust3', '$form_input_add_link_cust4', '$form_input_add_link_cust5', '$form_input_add_link_cust6')";
			$conn->Execute($query);
			$link_data[1] = $conn->Insert_ID("inl_custom","cust_id");
		}
		else
		{	
			$query="update inl_custom set cust1='$form_input_add_link_cust1', cust2='$form_input_add_link_cust2', cust3='$form_input_add_link_cust3', cust4='$form_input_add_link_cust4', cust5='$form_input_add_link_cust5', cust6='$form_input_add_link_cust6' where cust_id=" . $link_data[1];
		
			if (!$conn->Execute($query)) 
				return "$templ_exec?t=error&$l_error_db".base64_encode($conn->ErrorMsg());
		}
	}
	elseif($link_data[1])
	{	
		//delete custom fields if they are no longer used!
		$conn->Execute("DELETE FROM inl_custom WHERE cust_id=$link_data[1]"); 
		$link_data[1]=0;
	}

	if($admin==1)
		$query="UPDATE inl_links SET link_name='$form_input_add_link_name', link_url='$form_input_add_link_url', link_desc='$form_input_add_link_desc', link_date=$form_input_add_link_date, link_vis=$form_input_add_link_vis, link_image='$form_input_add_link_image', link_cust=$link_data[1], link_user=$form_input_add_link_user, link_pick=$form_input_add_link_pick, link_hits=$form_input_add_link_hits, link_votes=$form_input_add_link_votes, link_rating=$form_input_add_link_rating, link_expires='$form_input_add_link_expires_date', link_modified='$form_input_add_link_modified_date' WHERE link_id=$id";
	 //update link and reset pending flags
	else 
	{	
		$query = "UPDATE inl_links SET link_name='$form_input_add_link_name', link_url='$form_input_add_link_url', link_desc='$form_input_add_link_desc', link_image='$form_input_add_link_image', link_modified='".time()."', link_cust='".$link_data[1]."' WHERE link_id=$id";
		
		//permissions by category
		$qu = "SELECT DISTINCT cat_perm, inl_cats.cat_id from inl_lc, inl_cats WHERE link_id=$id AND inl_lc.cat_id=inl_cats.cat_id"; //get all cats
		$rs = &$conn->Execute($qu);
		while (!$rs->EOF) 
		{	
			//kill all cat references
			$conn->Execute("DELETE FROM inl_lc WHERE link_id=$id AND cat_id=".$rs->fields[1]); 

			if (check_perm($rs->fields[0],"links")==1)
				$conn->Execute("INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ($id,".$rs->fields[1].",1)");
			else
				$conn->Execute("INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ($id,".$rs->fields[1].",0)");
			update_link_count($rs->fields[1]);
			$rs->MoveNext(); 
		}
	}

	if ($conn->Execute($query) === false) 
		return "$templ_exec?t=error&$l_error_db".base64_encode($conn->ErrorMsg());
	
	if($admin==1)
	{	
		if(ereg("pending_link",$ses[destin])>0) //in pending
		{	
			$rs=&$conn->Execute("SELECT link_pend FROM inl_lc WHERE link_id=$id AND link_pend<0");
			if($rs && !$rs->EOF)
				$pending = $rs->fields[0];
			else
				$pending = 1;
		}
		else
			$pending = 0;
		settype($pending,"integer");
		
		//delete old cat references
		$conn->Execute("DELETE FROM inl_lc WHERE link_id=$id");
		//begin inserting cat entries
		$cats=split(",",$cat_list);
		reset($cats);
		
		while (list ($key, $value) = each($cats)) //avoiding holes in the list
		{	if($value && $value!="Home")
			{	if ($conn->Execute("INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ($id,$value,$pending)") === false)
					return "$templ_exec?t=error&$l_error_db".base64_encode($conn->ErrorMsg());
				update_link_count($value);
			}
			elseif($value=="Home")
				if ($conn->Execute("INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ($id,0,$pending)") === false)
					return "$templ_exec?t=error&$l_error_db".base64_encode($conn->ErrorMsg());
		}
		//end inserting cat entries
	}
	if ($admin!=1)
	{
		global $email_perm, $subject, $from, $reply, $user_data, $email_link;
		$query="select * from inl_links where link_id=$id";
		$rs = &$conn->Execute($query);
		if ($rs && !$rs->EOF) 
			$email_link=$rs->fields;
		$query="select * from inl_users where user_id=".$ses["user_id"];
		$rs = &$conn->Execute($query);
		if ($rs && !$rs->EOF) 
			$user_data=$rs->fields;
		include("includes/admin_email_lib.php");
	}

	if($email_perm[2]==1 && $admin!=1)
	{
		$body=email_parse("mail_admin_mod_link");
		if($u=get_admin_emails())
			@mail($u, $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
	}
	if($email_perm[11]==1 && $admin!=1){
		$body=email_parse("mail_user_mod_link");
		@mail($user_data["email"], $subject, $body, "From:$from\r\nReply-to:$reply");
	}

	#$attach=ereg_replace("\|","&",$attach);;
	if ($admin==1)
	{
		//$attach=ereg_replace("\|","&",$attach);
		//return "$templ_exec?$attach&having=$having";
		return "$templ_exec?".$ses["destin"]."&having=$having";
	}
	else
	{	$message=base64_encode($lu_confirm_linkupdate);
		return "$templ_exec?t=confirm&message=$message&attach=$attach&having=$having";
	}		
}

//for edit link purposes only
function get_link($id)
{	
	global $ses, $conn, $form_input_add_link_name, $form_input_add_link_url, $form_input_add_link_image, $form_input_add_link_desc, $form_input_add_link_cust1, $form_input_add_link_cust2, $form_input_add_link_cust3, $form_input_add_link_cust4, $form_input_add_link_cust5, $form_input_add_link_cust6,  $cat_list,$admin,$form_input_add_link_vis,$form_input_add_link_pick, $form_input_add_link_user, $form_input_add_link_day, $form_input_add_link_month, $form_input_add_link_year, $form_input_add_link_hits, $form_input_add_link_votes, $form_input_add_link_rating, $attach, $form_input_add_link_minute,$form_input_add_link_hour, $form_input_add_link_second,
	# MODIFICATION DATE 
	$form_input_add_link_modified_month, $form_input_add_link_modified_day, $form_input_add_link_modified_year,
	$form_input_add_link_modified_minute,$form_input_add_link_modified_hour, $form_input_add_link_modified_second,
	# EXPIRATION DATE 
	$form_input_add_link_expires_month, $form_input_add_link_expires_day, $form_input_add_link_expires_year, $form_input_add_link_expires_minute,$form_input_add_link_expires_hour, $form_input_add_link_expires_second;

	$query="Select link_name, link_url, link_image, link_desc, link_vis, link_pick, cust1, cust2, cust3, cust4, cust5, cust6, link_user, link_hits, link_votes, link_rating, link_date, link_expires, link_modified from inl_links left join inl_custom on link_cust=cust_id where link_id=$id";

	$rs = &$conn->Execute($query);
	if ($rs && !$rs->EOF) {
		$form_input_add_link_name=stripslashes($rs->fields[0]);
		$form_input_add_link_url=stripslashes($rs->fields[1]);
		$form_input_add_link_image=stripslashes($rs->fields[2]);
		$form_input_add_link_desc=stripslashes($rs->fields[3]);
		$form_input_add_link_vis=$rs->fields[4];
		$form_input_add_link_pick=$rs->fields[5];
		$form_input_add_link_hits=$rs->fields[13];
		$form_input_add_link_votes=$rs->fields[14];
		$form_input_add_link_rating=$rs->fields[15];
		$form_input_add_link_day=date("j",$rs->fields[16]);
		$form_input_add_link_month=date("n",$rs->fields[16]);
		$form_input_add_link_year=date("Y",$rs->fields[16]);
		$form_input_add_link_hour=date("H",$rs->fields[16]);
		$form_input_add_link_minute=date("i",$rs->fields[16]);
		$form_input_add_link_second=date("s",$rs->fields[16]);
		$form_input_add_link_cust1=stripslashes($rs->fields[6]);
		$form_input_add_link_cust2=stripslashes($rs->fields[7]);
		$form_input_add_link_cust3=stripslashes($rs->fields[8]);
		$form_input_add_link_cust4=stripslashes($rs->fields[9]);
		$form_input_add_link_cust5=stripslashes($rs->fields[10]);
		$form_input_add_link_cust6=stripslashes($rs->fields[11]);
		$form_input_add_link_user=stripslashes($rs->fields[12]);
		
		if ($rs->fields[17] > 0)
		{
			$form_input_add_link_expires_day=date("j",$rs->fields[17]);
			$form_input_add_link_expires_month=date("n",$rs->fields[17]);
			$form_input_add_link_expires_year=date("Y",$rs->fields[17]);
			$form_input_add_link_expires_hour=date("H",$rs->fields[17]);
			$form_input_add_link_expires_minute=date("i",$rs->fields[17]);
			$form_input_add_link_expires_second=date("s",$rs->fields[17]);
		}
		else
		{
			$form_input_add_link_expires_day	= 0;
			$form_input_add_link_expires_month	= 0;
			$form_input_add_link_expires_year	= 0;
			$form_input_add_link_expires_hour	= 0;
			$form_input_add_link_expires_minute	= 0;
			$form_input_add_link_expires_second	= 0;
		}

		if ($rs->fields[18] > 0)
		{
			$form_input_add_link_modified_day=date("j",$rs->fields[18]);
			$form_input_add_link_modified_month=date("n",$rs->fields[18]);
			$form_input_add_link_modified_year=date("Y",$rs->fields[18]);
			$form_input_add_link_modified_hour=date("H",$rs->fields[18]);
			$form_input_add_link_modified_minute=date("i",$rs->fields[18]);
			$form_input_add_link_modified_second=date("s",$rs->fields[18]);
		}
		else
		{
			$form_input_add_link_modified_day		= 0;
			$form_input_add_link_modified_month		= 0;
			$form_input_add_link_modified_year		= 0;
			$form_input_add_link_modified_hour		= 0;
			$form_input_add_link_modified_minute	= 0;
			$form_input_add_link_modified_second	= 0;
		}
		
	}

	if($admin==1)
	{	
		$cur_cat=0;
		$cat_list="";
		$u=" AND link_pend=0";
		//if(ereg("pending_link",$attach)>0){$u="";}
		if(ereg("pending_link",$ses[destin])>0)
			{$u="";}
		$rs = &$conn->Execute("SELECT cat_id FROM inl_lc WHERE link_id=$id$u");
		while($rs && !$rs->EOF)
		{	
			if(!$rs->fields[0])
				$rs->fields[0]="Home";
			$cat_list.=$rs->fields[0] . ",";
			$rs->MoveNext();
		}
	}
}

//copy of the function from cat_lib
//number of cats and links in the category and all parents, bottom up
function update_link_count($cat) //assumes that parent to be updated is sent
{	global $conn;
	if($cat) //not root
	{	//select all children of the parent, assumes they are fixed
		$numcats=0;
		$numlinks=0;
		$rs = &$conn->Execute("select cat_id, cat_cats, cat_links from inl_cats where cat_sub=$cat and cat_pend=0");
		while($rs && !$rs->EOF) //add up all of the children
		{	$numcats+=$rs->fields[1];
			$numcats+=1; //update cats of itself
			$numlinks+=$rs->fields[2];
			$rs->MoveNext();
		}
		//links of itself
		$rs = &$conn->Execute("select count(link_id) from inl_lc where cat_id=$cat and link_pend=0");
		if($rs && !$rs->EOF) 
			$numlinks+=$rs->fields[0];

		//update number of sub cats for current cat
		$conn->Execute("update inl_cats set cat_cats=$numcats, cat_links=$numlinks where cat_id=$cat");
		//get parent & recurse
		$rs = &$conn->Execute("select cat_sub from inl_cats where cat_id=$cat and cat_pend=0");
		if($rs && !$rs->EOF)
			update_link_count($rs->fields[0]);
	}
}

//same as in cats, top down
function update_all_link_count($sub=0) 
{	global $conn;
	$query="select cat_id from inl_cats where cat_sub=$sub and cat_pend=0";
	$val=0;
	//all childern and their links
	$rs = &$conn->Execute($query);
	
	while ($rs && !$rs->EOF) 
	{	
		$t=update_all_link_count($rs->fields[0]);
		$val+=$t;
		$query="Update inl_cats set cat_links=$t where cat_id = ".$rs->fields[0];
		$conn->Execute($query);

		$rs->MoveNext();
	}

	//its own links
	$query="select count(link_id) from inl_lc where cat_id=$sub and link_pend=0";
	$rs = &$conn->Execute($query);
	if ($rs && !$rs->EOF) 
	$val+=$rs->fields[0];

	return $val; 
}

function num_to_image($n)
{	if($n<0.25 || $n>5)
		return "0";
	if($n>=0.25 && $n<0.75)
		return "0_half";
	if($n>=0.75 && $n<1.25)
		return "1";
	if($n>=1.25 && $n<1.75)
		return "1_half";
	if($n>=1.75 && $n<2.25)
		return "2";
	if($n>=2.25 && $n<2.75)
		return "2_half";
	if($n>=2.75 && $n<3.25)
		return "3";
	if($n>=3.25 && $n<3.75)
		return "3_half";
	if($n>=3.75 && $n<4.25)
		return "4";
	if($n>=4.25 && $n<4.75)
		return "4_half";
	if($n>=4.75 && $n<=5)
		return "5";
}

## Modified in In-link 2.3.3
//user link data - checks for PENDING and VISIBLE and EXPIRED
function get_link_data($link_id)
{	
	global $conn;

	$link_data = array();
	$query = "SELECT inl_links.link_id, link_name, link_pick, link_desc, link_date, link_hits, link_rating, link_votes, link_numrevs, link_image, cust1, cust2, cust3, cust4, cust5, cust6, link_user, link_url, link_modified, link_expires FROM inl_links LEFT JOIN inl_lc ON inl_lc.link_id=inl_links.link_id LEFT JOIN inl_custom ON inl_links.link_cust=inl_custom.cust_id WHERE inl_links.link_id=$link_id AND link_pend=0 AND link_vis=1 AND".AddGetExpirationToQuery(time());	
	
	$rs = &$conn->Execute($query);
	if($rs && !$rs->EOF)
		$link_data = $rs->fields;

	return $link_data;
}
## End Modified

function masslinkapprove($pendlinks)
{
	global $conn, $action, $approved_link_expires;
	
	$UpdatedLinks = array();

	while (list ($link_id, $val) = each ($pendlinks)) 
	{

		$rs_cat = &$conn->Execute("SELECT cat_id FROM inl_lc WHERE link_id='$link_id'");

		//while (list ($link_id, $val) = each ($pendlinks)) {
		while($rs_cat && !$rs_cat->EOF) 
		{
			$val = $rs_cat->fields[0];

			$rs_id = &$conn->Execute("SELECT link_pend FROM inl_lc WHERE link_id='$link_id'");
			
			if($rs_id && !$rs_id->EOF) 
			{
				$lid = $rs_id->fields[0];
				if($lid < 0)
				{
					$lid=-$lid;
					
					$rs = &$conn->Execute("select link_cust from inl_links where link_id='$lid'");
					if ($rs && !$rs->EOF)
						if ($rs->fields[0])
							$conn->Execute("delete from inl_custom where cust_id='".$rs->fields[0]."'");

					//delete link itself
					$conn->Execute("delete from inl_links where link_id='$lid'");

					//clean up references (should already be Ok);
					$conn->Execute("delete from inl_lc where link_id=$lid");

					$conn->Execute("UPDATE inl_links SET link_id='$lid' WHERE link_id='$link_id'");			
					$conn->Execute("UPDATE inl_lc SET link_id='$lid' WHERE link_id='$link_id'");			

					$link_id = $lid;
				}
				elseif ($lid == 1)
				{
					if (!in_array($link_id, $UpdatedLinks) && $approved_link_expires>0)
					{
						
						$EpirationTime = time()+($approved_link_expires*86400);
						$sql = "UPDATE inl_links SET link_expires='".$EpirationTime."' WHERE link_id='".$link_id."' AND link_expires='0'"; 
						if ($rs = &$conn->Execute($sql))
							$UpdatedLinks[] = $link_id;	
					}

				}
			}

			$conn->Execute("update inl_lc set link_pend=0 where link_id='$link_id' and cat_id=$val");
			update_cat_count($val);

			global $la_button_approve_selected;

			if($action=="approvelink" || $action==$la_button_approve_selected){
				global $email_perm, $subject, $from, $reply, $user_data, $email_link;
				if($email_perm[9]==1){
					$query="select * from inl_links where link_id=$link_id";
					$rs = &$conn->Execute("$query");
					$email_link = $rs->fields;
					$query="select * from inl_users where user_id=".$email_link[5];
					$rs = &$conn->Execute("$query");
					$user_data = $rs->fields;
					include("../includes/admin_email_lib.php");
					$body=email_parse("mail_user_link_approved");

					if($user_data[5])
						@mail($user_data[5], $subject, $body, "From:$from<$reply>\r\nReply-to:$reply");
				}		
			}
		
			$rs_cat->MoveNext();
		}
	}
}

function masslinkdelete($pendlinks)
{
	global $conn, $sid, $ses;
			   
	while (list ($link_id, $val) = each ($pendlinks)) 
	{
		$rs = &$conn->Execute("SELECT cat_id FROM inl_lc WHERE link_id='$link_id'");

		while($rs && !$rs->EOF) 
		{
			$val=$rs->fields[0];			
			delete_link($link_id, $val);
			$rs->MoveNext();
		}		
	}
}

## Modified in In-link 2.3.3
function linkpath($cat, $DoLink = 0)
{
	global $conn, $la_navbar_seperator, $lu_navbar_seperator, $admin, $lu_nav_home, $la_nav_home, $sid, $session_get, $path_class;

	$catb = $cat;
	
	$path_class = is_null($path_class)? "small_path" : $path_class;

	if ($admin)
	{	
		$sep = $la_navbar_seperator;
		$home = $la_nav_home;
		$att_file = "navigate.php?t=navigate&";
	}
	else
	{	
		$sep = $lu_navbar_seperator;
		$home = $lu_nav_home;
		$att_file = "../../index.php?t=sub_pages&";
	}
	
	$cloc = "";

	if ($sid && $session_get)
		$att_sid = "&sid=".$sid;

	if ($cat != "0") 
	{
		do
		{
			$rs = &$conn->Execute("select cat_name, cat_sub from inl_cats where cat_id='$catb'");
			if (!$rs->EOF && $rs) 
			{
				
				if ($DoLink)
					$cloc = " $sep <a href=\"".$att_file."cat=".$catb.$att_sid."\" class=\"$path_class\">".$rs->fields[0]."</a>". $cloc;
				else
					$cloc =" $sep ".$rs->fields[0] . $cloc;

				$catb = $rs->fields[1];

			}
		
		} 
		while ($catb != "0" && !$rs->EOF && $rs);

		if ($DoLink)
			$cloc = "<a href=\"".$att_file."cat=0".$att_sid."\" class=\"$path_class\">".$home."</a>". $cloc;
		else
			$cloc = $home . $cloc;
	} 
	else
	{
		if ($DoLink)
			$cloc = "<a href=\"".$att_file."cat=0".$att_sid."\" class=\"$path_class\">".$home."</a>";
		else
			$cloc = $home;
	}

	return $cloc;
}
## End Modified in In-link 2.3.3

//user link data - checks for ALL LINKS
function _get_all_link_data($id)
{	
	global $conn;

	$query = "SELECT inl_links.link_id, link_name, link_pick, link_desc, link_date, link_hits, link_rating, link_votes, link_numrevs, link_image, cust1, cust2, cust3, cust4, cust5, cust6, link_user, link_url, link_vis, link_modified, link_expires, link_cust FROM inl_links LEFT JOIN inl_lc ON inl_lc.link_id=inl_links.link_id LEFT JOIN inl_custom ON inl_links.link_cust=inl_custom.cust_id WHERE inl_links.link_id='$id'";
	$rs = &$conn->Execute($query);
	$ret = ($rs && !$rs->EOF)? $rs->fields : 0;	 
		
	return $ret;
}

function getExpiredLinksQuery($time)
{
    global $ses, $pend, $cat, $lim, $link_order_c,$link_order,$link_sort,$link_sort_c, $force_pick, $admin, $link_query, $start , $having, $conn, $sql_type, $multiple_search_instances;
	
	//sort vars
	if($link_order_c) $link_order = $link_order_c;
	if($link_sort_c)  $link_sort = $link_sort_c;
	
	//$orderby = $force_pick? " link_pick desc," : " ORDER BY ";	
	$orderby.= " ORDER BY ".$ses["link_order"]." ".$ses["link_sort"];
					
	$query = $link_query;
		
	if ($having)
	{
		$que = "SELECT log_keyword, log_search from inl_search_log where log_id='$having'";
		$rs = &$conn->Execute($que);
		if ($rs && !$rs->EOF) 
		{
			$search_word = stripslashes($rs->fields[0]);
			$search_type = $rs->fields[1];
		}
			if ($search_type == 1)
			{
				$array = get_keywords($search_word);
				$field_array = do_search_where();
				$string = get_where_string($field_array, $array, "OR", "OR");
				$string = ereg_replace("OR)",")", $string);
				$string = ereg_replace(" OR $","", $string);
				
				$query = ereg_replace("cat_id","inl_lc.cat_id", $query);
				if($ses["user_perm"]==5) // editor
				    $query.= "LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id AND inl_cats.cat_user=".$ses["user_id"];
				$query.= "WHERE (".$string.") AND inl_lc.link_pend!=1 AND ".AddGetExpirationToQuery($time, 1);
			
			}
			
	}
	else 
	{
	    $query = ereg_replace("cat_id","inl_lc.cat_id", $query);
	    if($ses["user_perm"]==5) // editor
		  $query.= "LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id WHERE inl_lc.link_pend!=1 AND inl_cats.cat_user = ".$ses["user_id"];
		
		$query.= " WHERE ".AddGetExpirationToQuery($time, 1);

	}

	if($sql_type!="postgres7")
		$ret = $query.$orderby;
	/*
	else
	{
		//$new_link_query=ereg_replace("SELECT DISTINCT","SELECT DISTINCT ON (link_id)",$query);
		//$inside_orderby=ereg_replace("ORDER BY ","ORDER BY link_id,",$orderby);
		
		//return print_links("SELECT * FROM (".$new_link_query.$having1.$inside_orderby.") AS foo ".$orderby, "pend_links", $lim, $start);
		//$ret = "SELECT * FROM (".$new_link_query.$inside_orderby.") AS foo ".$orderby;
	}
	*/
	return $ret;
}

function renewLinks($links, $days = 0)
{
    global $conn;
    
    if (!count($links) || ($days < 0))
        return;
          
    $new_expiration = $days? time()+($days*86400) : 0;
           
    foreach ($links as $curr)   
        $linkIDs.= $curr.", ";
    $linkIDs = ereg_replace(", $","", $linkIDs);
    
    $sql = "UPDATE inl_links SET link_expires='".$new_expiration."' WHERE link_id IN (".$linkIDs.")";
    $rs = &$conn->Execute($sql);
   
}

function doLinksCleanUp($type = 0)
{
	global $conn;

	settype($sql, "array");

	if (!$type || ($type == 1))
		$sql[] = "SELECT t1.link_id FROM inl_lc AS t1 LEFT JOIN inl_links AS t2 ON t1.link_id=t2.link_id WHERE t2.link_id IS NULL GROUP BY link_id";
	if (!$type || ($type == 2))
		$sql[] = "SELECT t1.link_id, link_name FROM inl_links AS t1 LEFT JOIN inl_lc AS t2 ON t1.link_id=t2.link_id WHERE t2.link_id IS NULL GROUP BY link_id";

	if (count($sql))	
	{
		foreach($sql as $curr)
		{
			$rs = &$conn->Execute($curr);
			while ($rs && !$rs->EOF) 
			{	
				delete_link($rs->fields[0], "all");
				$rs->MoveNext();
			}
		}
	}
}


?>