<?php
## In-link Admin Language File - English
## Author: Intechnic Corporation
## Date: 07/15/2001
##
## This file is designed for the following version of In-link: 2.0.6
## You can modify the text in this file to suit your language needs. 
## Make sure to escape quotation marks with \" . 

#########################################################################################
#system vars
$la_char_set								=   "windows -1256
";
$la_navbar_seperator						=	" >";
$la_pagetitle								=	"DalilTop ::  ";
$la_this_language							=	"Arabic";

#########################################################################################
#navigation text

$la_admin_menu_title						=	"Administration Menu";
$la_nav1									=	"Navigate & Modify";
$la_nav2									=	"Data Validation";
$la_nav3									=	"Users & Permissions";
$la_nav4									=	"Logs & Statistics";
$la_nav5									=	"Customization";
$la_nav6									=	"Configuration";
$la_nav7									=	"Backup & Import";
$la_nav8									=	"License & Support";
$la_nav9									=	"Help";
$la_nav10									=	"Search Results";

#########################################################################################
#titles

$la_duplicate								=	"Duplicate";
$la_title_add_category						=	"Add Category";
$la_title_add_link							=	"Add Link";
$la_title_add_review						=	"Add Review";
$la_title_advanced_search					=	"Advanced Search";
$la_title_backup							=	"Backup";
$la_title_backup_import						=	"Backup & Import";
$la_title_credits							=	"Credits";
$la_title_data_structure					=	"Data Structure";
$la_title_edit_category						=	"Edit Category";
$la_title_edit_link							=	"Edit Link";
$la_title_edit_review						=	"Edit Review";
$la_title_email								=	"E-mail";
$la_title_error								=	"Error";
$la_title_import							=	"Import";
$la_title_license							=	"License";
$la_title_modules							=	"Modules";
$la_title_moving							=	"Moving";
$la_title_navigate							=	"Navigate";
$la_title_output							=	"Output";
$la_title_pending							=	"Pending Data";
$la_title_pending_cats						=	"Pending Categories";
$la_title_pending_links						=	"Pending Links";
$la_title_pending_reviews					=	"Pending Reviews";
$la_title_pending_users						=	"Pending Users";
$la_title_regional							=	"Regional";
$la_title_reviews							=	"Reviews";
$la_title_reports							=	"Reports";
$la_title_restore							=	"Restore";
$la_title_search							=	"Search";
$la_title_search_log						=	"Search Log";
$la_title_security							=	"Security";
$la_title_statistics						=	"Statistics";
$la_title_support							=	"Support";
$la_title_system							=	"System";
$la_title_themes							=	"Themes";
$la_title_user_list							=	"User List";
$la_title_user_settings						= 	"Permissions & Users";
$la_title_validate_data						=	"Data Validation";

#########################################################################################
#backup/import

$la_backup_inlink							=	"Backup your In-link database";
$la_cat_path								=	"Path to Category's DB";
$la_cat_specific							=	"Categories Spesifications";
$la_import_data								=	"Import data from other databases";
$la_link_path								=	"Path to Link's DB";
$la_link_specific							=	"Links Spesifications";
$la_restore_inlink							=	"Restore your In-link database";


#########################################################################################
#credits

$la_thank_you								=	"Intechnic Corporation would like to thank a number of people who have helped us to develop this wonderful product. ";
$la_user_thank_you							=	"And the following people for their assistance, support and encouragement";
$la_thank_you_beta							=	"Beta Testing and Debugging:";
$la_thank_you_translate						=	"Translations into different languages:";

#########################################################################################
#drop values

$la_drop_add_approval						=	"Allowed upon administrator validation";
$la_drop_add_no								=	"Not allowed";
$la_drop_add_yes							=	"Directly to the database";
$la_drop_and								=	"AND";
$la_drop_as_many_as_found					=	"as many as found";
$la_drop_ascending							=	"Ascending";
$la_drop_both								=	"Both";
$la_drop_categories							=	"Categories";
$la_drop_date								=	"Date";
$la_drop_default							=	"(default)";
$la_drop_default_admin						=	"Administrator (default)";
$la_drop_desc								=	"Description";
$la_drop_descending							=	"Descending";
$la_drop_editors_pick						=	"Editor's pick";
$la_drop_hits								=	"Hits";
$la_drop_image								=	"Image";
$la_drop_least								=	"Least";
$la_drop_links								=	"Links";
$la_drop_most								=	"Most";
$la_drop_name								=	"Name";
$la_drop_new_links							=	"New links";
$la_drop_none								=	"None";
$la_drop_numlinks							=	"Number of links";
$la_drop_numsubs							=	"Number of subs";
$la_drop_or_default							=	"OR (default)";
$la_drop_perm								=	"Permissions";
$la_drop_pop_links							=	"Pop links";
$la_drop_pop_value							=	"Pop value";
$la_drop_rating								=	"Rating";
$la_drop_subcategories						=	"Subcategories";
$la_drop_top_links							=	"Top links";
$la_drop_vis								=	"Visibility";
$la_drop_votes								=	"Votes";
$la_drop_url								=	"URL";
$la_drop_user								=	"User";


#########################################################################################
#buttons

$la_button_add_cat							=	"Add Category";
$la_button_add_link							=	"Add Link";
$la_button_add_review						=	"Add Review";
$la_button_add_to_cat						=	"Add to this category";
$la_button_add_user							=	"Add User";
$la_button_approve							=	"Approve";	
$la_button_approve_selected					=	"Approve Selected";
$la_button_back								=	"Back";
$la_button_cancel							=	"Cancel";
$la_button_delete							=	"Delete";
$la_button_delete_selected					=	"Delete Selected";
$la_button_display_all						=	"Display All";
$la_button_done								=	"Done";
$la_button_edit								=	"Edit";
$la_button_edit_cat							=	"Edit Category";
$la_button_edit_link						=	"Edit Link";
$la_button_edit_review						=	"Edit Review";
$la_button_edit_user						=	"Edit User";
$la_button_go								=	" Go ";
$la_button_load								=	"Load";
$la_button_login							=	"Login";
$la_button_move_to_cat						=	"Move to this category";
$la_button_new_user							=	"New User";
$la_button_ok								=	" OK ";
$la_button_only								=	" only";
$la_button_preview							=	"Preview";
$la_button_recount							=	"Recount";
$la_button_register							=	"Register";
$la_button_reset							=	"Reset";
$la_button_search							=	"Search";
$la_button_search_cats						=	"Search Cats";
$la_button_search_links						=	"Search Links";
$la_button_select_all						=	"Select All";
$la_button_send								=	"Send";
$la_button_unselect_all						=	"Unselect All";
$la_button_update							=	"Update";
$la_button_update_user						=	"Update User";
$la_button_view								=	"View";


#########################################################################################
#field help

$la_date_format1							=	"(mm-dd-yyyy)";
$la_min_one									=	"(Minimum 1)";
$la_min_zero								=	"(Minimum 0)";
$la_min_zero_max_ten						=	"(Minimum 0, maximum 5)";
$la_misc_help1								=	"(Overwrites predefined, minimum 0, can use decimals)";


#########################################################################################
#hints

$la_change_language_caution						=	"Caution! Use caution if you are switching to a language you don't speak. The entire administration utility will be translated and you might have a problem changing it back. :)";
$la_dont_screw_up_inlink						=	"Please, exercise caution when modifying the options below. Your copy of In-link may stop functioning if the values are modified incorrectly.";
$la_import_warning1								= "In order the import to work you need to have both databases on the same server and to have the full db permissions for both users!";
$la_import_warning2								= "If you run the import more than once, please clean up your Browser cache!";
$la_import_warning3								= "The import is creating a temporary table called temp_cat. If the import gets interrupted somehow and does not finish successfully make sure you delete that table!";
$la_import_warning4								= "All the lost categories will be imported in a disabled category in Root called - Lost and Found";

$la_language_sets_contained_in	       			=	"Language sets are contained in the \"languages\" directory. You can easily modify any system messages in the sets or even create your own language sets! Additional language sets are available for download on the In-link site.";
$la_mass_approving_help							=	"Approving a link or category would send a custom e-mail message to the person who submitted it; mass approving selected links or categories simply adds the to the live database without sending out any messages.";
$la_mass_denying_help							=	"Denying a link or category allows you to send a custom e-mail to the person who submitted it; mass deleting selected links simply deletes them from the pending list. ";
$la_navigate_to_add							="Browse to the appropriate category to add a new link or subcategory";
$la_navigate_to_move						="Browse to the appropriate category to select new category for the move";
$la_rating_graphics_library_stored_under	=	"The graphics library for these files is stored under \"images/icons/ratings/\". You can easily modify any of the files or upload your own! Additional icons are available for the download at the In-link's site.";
$la_root_password_change_warning			=	"The root user overrides all of the admins and can not be deleted. Please, exercise caution when changing the root password. Your data can not be recovered if the password is lost.";
$la_sql_warning								=	"Use at your own risk! This utility gives you full access to the database. You can easily damage the system by executing a wrong query";
$la_what_is_a_module				        =	"Modules can extend the functionality of your In-link system my allowing you to use custom tags in the templates.";
$la_what_is_a_theme							=	"A theme is a set of templates, images and rating icons combined with a cascading style sheet file. The themes are located in \"themes\\\" directory. You can download new themes from our web site or add and modify your owns. Just place them in their own directory under \"themes\\\" and use this page to switch between them.";


#########################################################################################
#field lables

$la_a_link_is_added							=	"A new link is added";
$la_a_link_is_approved						=	"A new link is approved";
$la_a_link_is_denied						=	"A new link is denied";
$la_a_link_is_validated						=	"A link is approved";
$la_a_mod_is_added							=	"An existing link is modified";
$la_a_mod_is_approved						=	"A modification is approved";
$la_a_mod_is_denied							=	"A modification is denied";
$la_a_new_category_is_suggested				=	"A new category is suggested:";
$la_a_new_link_is_added						=	"A new link is added :";
$la_a_new_review_added						=	"A new review is added:";
$la_a_new_user_is_approved					=	"A new user is approved:";
$la_a_new_user_is_denied					=	"A new user is denied:";
$la_a_new_user_is_registered				=	"A new user is registered:";
$la_added									=	"Added";
$la_admin									=	"Admin";
$la_administrator_email_address				=	"Root E-mail Address:";
$la_administrator_notices					=	"Administrator Notices";
$la_advanced_search							=	"Advanced Search";
$la_advanced_search_allowed					=	"Advanced Search Allowed";
$la_all										=	"All";
$la_all_links_valid							=	"All link URL's are valid";
$la_allow_adding_links_to_root_category	   	=	"Allow Adding Links to the Root Category:";
$la_all_users								=	"All Users";
$la_an_old_link_is_modified					=	"An existing link is modified:";
$la_and_that_are							=	"And That Are";
$la_apply_cat_perm							=	"Apply these permissions to all categories";
$la_apply_cat_perm_sub						=	"Apply these permissions to all sub categories below";
$la_atleast_3								=	"(at least 3 chars, ";
$la_average_vote							=	"Average Vote";
$la_body									=	"Body";
$la_boolean_type_search						=	"Boolean Type of Search";
$la_break_output_into_number_of_columns		=	"Break Up the Output Into # of Columns:";
$la_can_user_change_category_sorting		=	"Can the User Change How Categories Are Sorted:";
$la_can_user_change_link_sorting			=	"Can the User Change How Links Are Sorted:";
$la_can_user_specify_bool_search		    =	"Can the User Specify the Boolean Type of Search";
$la_can_user_specify_number					=	"Can the User Specify the Number of Results Returned";
$la_can_user_specify_type_search		    =	"Can the User Specify the Type of Search";
$la_cat_new									=	"new";
$la_cat_owner								=	"Category Owner";
$la_cat_permissions							=	"Permissions to add links to this category:";
$la_cat_pick								=	"pick";
$la_categories								=	"Categories";
$la_categories_custom_fields			    =	"Categories Custom Fields:";
$la_categories_custom_fields1			    =	"Custom Field Name #1";
$la_categories_custom_fields2			    =	"Custom Field Name #2:";
$la_categories_custom_fields3			    =	"Custom Field Name #3:";
$la_categories_custom_fields4			    =	"Custom Field Name #4:";
$la_categories_custom_fields5			    =	"Custom Field Name #5:";
$la_categories_custom_fields6			    =	"Custom Field Name #6:";
$la_category_graphic						=	"Category Graphic";
$la_choose_custom							=	"Or Choose Custom";
$la_choose_graphics_file_from_library		=	"If Marked Graphically Choose a Graphics File From Our Library:";
$la_choose_language_file_to_modify			=	"Choose A Language File to Modify";
$la_current_language						=	"Current Language";
$la_current_theme							=	"Current Theme";
$la_custom_cat1								=	"Custom #1";
$la_custom_cat2								=	"Custom #2";
$la_custom_cat3								=	"Custom #3";
$la_custom_cat4								=	"Custom #4";
$la_custom_cat5								=	"Custom #5";
$la_custom_cat6								=	"Custom #6";
$la_custom_link1							=	"Custom #1";
$la_custom_link2							=	"Custom #2";
$la_custom_link3							=	"Custom #3";
$la_custom_link4							=	"Custom #4";
$la_custom_link5							=	"Custom #5";
$la_custom_link6							=	"Custom #6";
$la_custom_reports							=	"Custom Reports";
$la_custom_sql_query						=	"Custom SQL Query";
$la_custom_user1							=	"Custom #1";
$la_custom_user2							=	"Custom #2";
$la_custom_user3							=	"Custom #3";
$la_custom_user4							=	"Custom #4";
$la_custom_user5							=	"Custom #5";
$la_custom_user6							=	"Custom #6";
$la_database								=	"Database";
$la_databases								=	"Database";
$la_date									=	"Date";
$la_date_created							=	"Date Created";
$la_date_format								=	"Date Format:";
$la_default_search_of						=	"Default Search of";
$la_del_user								=	"Are you sure you want to delete this user?";
$la_delete									=	"Delete";
$la_description								=	"Description";
$la_development_team						=	"Development Team:";
$la_disabled								=	"Disabled";
$la_display_text_counters_as_images			=	"Display Text Counters As Images:";
$la_displaying								=	"Displaying";
$la_displaying_dead_links					=	"Displaying Dead Links";
$la_do_advanced_search_by					=	"Do an Advanced Type-Defined Search By the Following Fields";
$la_do_simple_search_by						=	"Do a Simple Keyword Search By the Following Fields";
$la_duplicate_link_check					=	"Duplicate Links Check";
$la_duplicate_links							=	"Duplicate Links";
$la_duplicates								=	"Duplicates";
$la_edit									=	"Edit";
$la_edit_pick								=	"Edit Pick";
$la_editor_pick								=	"Editor's Pick";
$la_editting								=	"Editing";
$la_email									=	"E-mail";
$la_error_reporting							=	"Error Reporting";
$la_feedback								=	"Feedback";
$la_first_name								=	"First Name";
$la_for_every_field_box_displayed			=	"(for every field there will be a text box displayed)";
$la_force_pick								=	"Display Editor Picks before regular links";
$la_from									=	"From";
$la_full_name								=	"Full Name";
$la_general									=	"General";
$la_go_to_page								=	"Go to Page";
$la_hidden									=	"Hidden";
$la_hits									=	"Hits";
$la_i_want_to_see							=	"I Want to See";
$la_images_path								=	"Images Path";
$la_individual_text_not_shown			    =	"(individual text boxes are not shown)";
$la_inlink_is_licensed_for_use_on_this_server =	"In-link is Licensed For the Use on This Server: ";
$la_inlink_server_path						=	"In-link Server Path";
$la_inlink_site								=	"In-link Site";
$la_inlink_version				            =	"In-link Version";
$la_install									=	"Install";
$la_keyword									=	"Keyword";
$la_language								=	"Language:";
$la_language_sets_path						=	"Language Sets Path";
$la_last_name								=	"Last Name";
$la_link_graphic							=	"Link Graphic";
$la_link_owner								=	"Link Owner";
$la_link_rating_as							=	"Link Rating As:";
$la_links									=	"Links";
$la_links_custom_fields						=	"Links Custom Fields";
$la_links_custom_fields1					=	"Custom Field Name #1:";
$la_links_custom_fields2					=	"Custom Field Name #2:";
$la_links_custom_fields3					=	"Custom Field Name #3:";
$la_links_custom_fields4					=	"Custom Field Name #4:";
$la_links_custom_fields5					=	"Custom Field Name #5:";
$la_links_custom_fields6					=	"Custom Field Name #6:";
$la_links_validation						=	"Links Validation";
$la_mark_categories_as						=	"Mark Categories as:";
$la_mark_links_as							=	"Mark Links as:";
$la_meta_desc								=	"META description";
$la_meta_keywords							=	"META keywords"; 
$la_module_usage							=	"Module Usage";
$la_modules_installed						=	"Modules Installed";
$la_move									=	"Move";
$la_mysql_database							=	"MySQL Database";
$la_mysql_password							=	"MySQL Password";
$la_mysql_server							=	"MySQL Server";
$la_mysql_user_name							=	"MySQL User Name";
$la_name									=	"Name";
$la_new							            =	"new";
$la_new_root_password						=	"New Root Password:";
$la_new_users								=	"New User Registration";
$la_next									=	"Next";
$la_no										=	"No";
$la_no_categories							=	"No Categories.";
$la_no_dead_links							=	"No Dead Links";
$la_no_duplicate							=	"No Duplicate Links";
$la_no_links								=	"No Links.";
$la_no_reviews								=	"No Reviews.";
$la_no_users								=	"No Users In the System!";
$la_not_allow_reviews						=	"Not allow multiple reviews from the same user for number of days:";
$la_not_allow_votes							=	"Not allow multiple votes from the same user for number of days:";
$la_notregistered_visitors					=	"Not Registered Visitors";
$la_number_of								=	"Number of";
$la_number_of_days_category_is_new			=	"The Number of Days to Consider a Category New:";
$la_number_of_days_link_is_new				=	"The Number of Days to Consider a Link New:";
$la_number_of_resulting_categories_per_page	=	"Number of Resulting Categories Per Page:";
$la_number_of_resulting_links_per_page		=	"Number of Resulting Links Per Page:";
$la_old_root_password						=	"Old Root Password:";
$la_order_output							=	"Order Output By";
$la_ordering								=	"Ordering";
$la_output_language_pack					=	"Output Language Pack";
$la_pass_not_match							=	"Passwords Do Not Match";
$la_pass_success							=	"Password Changed Successfully.";
$la_password								=	"Password";
$la_paths									=	"Paths";
$la_pend_reviews							=	"Pending Reviews";
$la_pending									=	"Pending";
$la_percent_cutoff_for_link_to_be_popular	=	"The Top Number of Links Rated By Hits to Be Considered <i>Popular</i>:";
$la_percent_cutoff_for_link_to_be_top		=	"The Top Number of Links Rated By Votes to Be Considered <i>Top</i>:";
$la_permissions								=	"Permissions";
$la_pick									=	"pick";
$la_pick_template							=	"Use a separate template for Editor Picks";
$la_pop										=	"pop";
$la_processing								=	"Processing";
$la_rating									=	"Rating";
$la_re_password								=	"Retype Password";
$la_records									=	"Records";
$la_reg_number								=	"Registration Number:";
$la_regional_date_format					=	"Regional Date Format:";
$la_registered_users						=	"Registered Users";
$la_reply_to									=	"Reply-to";
$la_reset_count								=	"Are you sure you want to reset the counter?";
$la_return_number_results					=	"Return Number of Results";
$la_retype_password							=	"Retype Password:";
$la_rev_owner								=	"Review Owner";
$la_review									=	"Review";
$la_reviews									=	"Reviews";
$la_reviews_and_votes						=	"Reviews & Votes";
$la_rootcat									=	"Adding links to root category";
$la_search									=	"Search";
$la_search_type								=	"Search Type";
$la_searches								=	"Searches";
$la_select_a_language_for_use_with_inlink	=	"Select a Language For Use With In-link:";
$la_select_settings_for_your_custom_report	=	"Select Settings For Your Custom Report:";
$la_show									=	"Show:";
$la_simple_search							=	"Simple Search";
$la_site_address							=	"Site Address";
$la_site_name								=	"Site Name";
$la_software_license_and_user_agreement		=	"Software License & User Agreement";
$la_sort_by									=	"Sort By";
$la_sorting									=	"Sorting";
$la_status									=	"Status";
$la_subject									=	"Subject";
$la_success_backup							=	"Database was backed up successfully";
$la_success_restore							=	"Database was restored up successfully";
$la_suggest_cat								=	"Suggesting a new category";
$la_support									=	"Support";
$la_template_sets_path						=	"Template Sets Path";
$la_that_are_contain						=	"That Are/Contain";
$la_theme_for_output						=	"Choose the Theme For In-link Output";
$la_theme_to_modify							=	"Choose a Theme Template to Modify";
$la_this_copy_of_inlink_is_registered_to	=	"This Copy of In-link is Registered to:";
$la_to										=	"To";
$la_to_all_users							=	"To: All Users";
$la_to_chang_field_contact_inlink		    =	"In Order to Modify This Field, Please Contact In-link's Customer Support.";
$la_to_keep_leave_blank						=	"to keep old password, leave blank)";
$la_top										=	"top";
$la_total_linkhits							=	"Total Link Hits";
$la_total_votes					            =	"Total Votes";
$la_url										=	"URL";
$la_url_path								=	"Url Path";
$la_user									=	"User";
$la_user_enabled							=	"User Enabled";
$la_user_name				        		=	"Username";
$la_user_notices							=	"User Notices:";
$la_username				        		=	"Username";
$la_users									=	"Users";
$la_users_custom_fields						=	"Users Custom Fields";
$la_users_custom_fields1					=	"Custom Field Name #1:";
$la_users_custom_fields2					=	"Custom Field Name #2:";
$la_users_custom_fields3					=	"Custom Field Name #3:";
$la_users_custom_fields4					=	"Custom Field Name #4:";
$la_users_custom_fields5					=	"Custom Field Name #5:";
$la_users_custom_fields6					=	"Custom Field Name #6:";
$la_visible									=	"Visible";
$la_visitors				               	=	"Visitors";
$la_votes									=	"Votes";
$la_yes										=	"Yes";

#########################################################################################
#errors

$la_date_time								=	"Date/Time";
$la_email_used								=	"This Email already exists";
$la_error_404								=	"Can not open the file";
$la_error_db								=	"Database Error!";
$la_error_file_not_found					=	"File is available:";
$la_error_pass_match						=	"The passwords you entered do not match.";
$la_error_pass_wrong						=	"The password you entered is incorrect.";
$la_error_review_not_filled					=	"Review cannot be empty";
$la_invalid_entry							=	"Invalid Entry";
$la_mailing_list							=	"Mailing List";
$la_no_search_logs							=	"No Search Logs in the System";
$la_table_type								=	"Table Type";
$la_username_used							=	"This Username already exists";


#########################################################################################
#confirmations
$la_confirm									=	"Confirm";
$la_delete_rev								=	"Are you sure you want to delete this review?";
$la_delete_link								=	"Are you sure you want to delete this link?";
$la_delete_cat								=	"Are you sure you want to delete this category, all of it's subcategories and all the links that belong to them?";
$la_reset_log								=	"Are you sure you want to reset the Search Log?";
$la_confirm_move							=	"Are you sure you want to move this link?";	
$la_confirm_move_inst						=	"Do you want to move only this instance of the link";
$la_confirm_move_inst2						=	"referenced in";
$la_confirm_move_inst3						=	"or all instances";
$la_confirm_del_inst						=	"Do you want to delete only this instance of the link";
$la_confirm_del_inst2						=	"referenced in";
$la_confirm_del_inst3						=	"or all instances of the link (physical link and all other references ";


#########################################################################################
#addlink template

$la_additional_cats							=	"Additional Categories:";
$la_add_cat									=	"Add this category";
$la_remove									=	"Remove";
$la_select									=	"Select";
$la_submitting_to							=	"You are submitting to:";


###########################
## 2.0.6 add-ons
$la_importgt_cannot_open_db					=	"Cannot open the database:";
$la_import_troubleshooting					=	"Troubleshooting";

###########################
## 2.0.7 add-ons
$la_category_missing						=	"No category selected!";

###########################
## 2.0.7 add-ons
$la_enable_html								=	"Enable HTML?";
$la_warning_html_enable						=	"Warning: Enabling HTML is a security risk and could damage the system, if used improperly!";

###########################
## 2.0.9 add-ons
$la_validate_spec							=	"Validation Specifications";
$la_display_empty_urls						=	"Display empty URL's as dead?";

###########################
## 2.0.10 add-ons
$la_nav_home								=	"Home";

###########################
## 2.1.0 add-ons
$la_sql_server								=	"SQL Server";
$la_sql_user_name							=	"SQL User Name";
$la_sql_password							=	"SQL Password";
$la_sql_database							=	"SQL Database";
$la_sql_type								=	"SQL Database Type";
$la_editor									=	"Editor";

$la_failed_session							=	"Failed to create a session";
$la_login_incorrect							=	"Login Incorrect";
$la_login_expired							=	"Login expired or not logged in";
$la_click_to_login1							=	"Click";
$la_click_to_login2							=	"here";
$la_click_to_login3							=	"to login";

$la_session_control							=	"Session Control";
$la_session_handeling						=	"In-link will handle user sessions via:";
$la_session_cookies							=	"Cookies";
$la_session_get								=	"GET Method";
$la_session_both							=	"Both";
$la_session_timeout							=	"Users sessions will timeout (in seconds):";

$la_change_all_subcat_users					=	"Change all sub categories to this user?";
$la_keep_subcat_editors						=	"Keep existing sub category users, if they are editors?";

$la_backup_no_tables						=	"No tables found";
$la_backup_error_writing_file				=	"Writing to the file failed:";

###########################
## 2.2.4 add-ons
$la_nav11									=	"Database Maintenance & Cleanup";
$la_title_data_cleanup						=	"Data Cleanup";
$la_title_database_maintenance_cleanup		=	"Database Maintenance & Cleanup";
$la_button_proceed							=	"Proceed";
$la_update_links_cats						=	"Update link and category count?";
$la_show_url								=	"Display link URL in status bar?";
$la_multiple_search_instances				=	"Show multiple link instances in Search results?";

###########################
## 2.2.5 add-ons
$la_copy									=	"Copy";
$la_button_copy_to_cat						=	"Copy to this category";
$la_navigate_to_copy						=	"Browse to the appropriate category to select new category for the copy";
$la_title_copying							=	"Copying";
$la_drop_email_confirmation					=	"Allowed with EMail confirmation";
$la_duplicate_user_email_check				=	"Duplicate User EMails Check";
$la_title_users_duplicate_email				=   "List of users with duplicate EMail addresses";
###########################
## 2.2.6 add-ons
$la_extended_search							=	"Use extended search";
$la_search_highlighting						=	"Highlighting keywords in the search result";
$la_search_highlighting_open				=	"Open";
$la_search_highlighting_close				=	"Close";
$la_simple_link_search_on					=	"Simple link search on";
$la_simple_cat_search_on					=	"Simple category search on";

$la_simple_search_link_name					=	"Link name";
$la_simple_search_link_desc					=	"Link description";
$la_simple_search_link_url					=	"Link URL";
$la_simple_search_link_image				=	"Link image";
$la_simple_search_link_cust1				=	"Custom1";
$la_simple_search_link_cust2				=	"Custom2";
$la_simple_search_link_cust3				=	"Custom3";
$la_simple_search_link_cust4				=	"Custom4";
$la_simple_search_link_cust5				=	"Custom5";
$la_simple_search_link_cust6				=	"Custom6";

$la_simple_search_cat_name					=	"Category name";
$la_simple_search_cat_desc					=	"Category description";
$la_simple_search_cat_image					=	"Category image";
$la_simple_search_cat_cust1					=	"Custom1";
$la_simple_search_cat_cust2					=	"Custom2";
$la_simple_search_cat_cust3					=	"Custom3";
$la_simple_search_cat_cust4					=	"Custom4";
$la_simple_search_cat_cust5					=	"Custom5";
$la_simple_search_cat_cust6					=	"Custom6";
$la_field_select_error						=	"At least one field should be selected";
$la_link_in_current							=	"Links in current category";
$la_link_in_subcats							=	"Links in sub-categories";
$la_link_in_entire							=	"Links in entire directory";
$la_error_for_adv_search					=	"Please enter at least 1 keyword for search";
$la_error_for_simple_search					=	"Please enter at least 4 characters";

#########################################################################################
#New for version 2.2.8
$la_related_to								=	"Related to";
$la_relate_cat								=	"Relate to this Category";
$la_choose_rel_cat							=	"Choose a Related Category";
$la_break_output_into_number_of_rel_columns =	"Number of Columns for Related Categories";
#########################################################################################
#New for version 2.2.9
$la_guest									=	"Guest";
$la_invalid_search_keywords					=	"Invalid Search Keywords";
$la_keywords								=	"Keywords";
$la_new_keyword								=	"New Keyword";
$la_add										=	"Add";
$la_presistent_conection					=	"User persistent connection to the Database";
$la_warning_pconnect						=	"Persistent connections require more server resources"; 
$la_support_forum							=	"Support Forum";
$la_support_system							=	"Support System";
$la_sub_preview_links						=	"Subcategory preview links";


#########################################################################################
#New for version 2.3.0
$la_title_users_bans						=	"User Bans";
$la_button_ban								=	"Ban";
$la_button_unban							=	"Unban";
$la_title_ban								=	"Ban a User";

$la_text1_ban								=	"You are about to ban this user.";
$la_title_ban_user_actions					=	"User status";
$la_ban_ip_addr								=	"IP Address";
$la_ban_delete_user							=	"Delete this user";
$la_ban_leave_user							=	"Leave as is";
$la_ban_disable_user						=	"Disable this user";
$la_ban_value								=	"Value";
$la_ban_exclusion							=	"Exclusion";
$la_ban_filter								=	"Filter results by";
$la_links_banning							=	"Banned Links";
$la_title_ban_link							=	"Links Banning Definitions";
$la_ban_confirm								=	"Are you sure you want to Ban this URL?";
$la_ban_delete								=	"Ban and Delete";
$la_ban_disable								=	"Ban and Disable";
$la_ban_only								=	"Ban Only";
$la_banned									=   "Banned";

$la_banned_links_management_hint			=	"Please use comma (,) sign after each exclusion";
$la_link_expired							=	"Expired";
$la_link_modified							=	"Modified";
$la_unban_add_exclusion						=	"Add to Exclusions";
$la_unban_complete							=	"Complete Unban";
$la_unban_confirm							=	"Add URL to Exclutions, or do complete record Unban?";
$la_date_modified							=	"Date Modified";
$la_date_expires							=	"Date Expires";
$la_direct_link_expiration					=	"Link expiration (after added directly)";
$la_approved_link_expiration				=	"Link expiration (after pending approved)";
$la_days									=	"days";
$la_use_detailed_page_for_links				=	"Use detailed page for links";
$la_error_for_simple_search_less_then_4ch	=	"Please enter at least 4 characters";
$la_link_in_results							=	"Links in results";
$la_drop_relevance                          =   "Relevance";

#########################################################################################
#New for version 2.3.1
$la_simple_search_importance_value          =   "Field importance";
$la_limit_from_0_to_9                       =   "(value from 0 to 9)";
$la_search_PowerImportanceIfRequiredKewordIn=   "Increase importance if field contains a required keyword by";
$la_search_value_in_percents                =   "value in percents";
$la_simple_search_relevance                 =   "Relevance Settings for Simple link search";
$la_simple_search_relevance_components      =   "Search Relevance depends on";
$la_simple_keywords_in_link_fields			=	"Keyword Relevance";
$la_simple_link_hits_relevance				=	"Link hits";
$la_simple_link_rating_relevance			=	"Link rating";
$la_total_relevance_value					=	"Total Search Relevance must equals 100%";
$la_link_expires							=	"Expires";
$la_expired									=	"Expired";
$la_expired_links                           =   "Expired Links";
$la_title_expired_links                     =   "Expired Links";
$la_button_delete_selected_expired          =   "Delete Selected";
$la_force_order_ext_search_by_rel           =   "Suggest Order by Relevance for Extended Search Results";
$la_button_renew_selected                   =   "Renew Selected For";
$la_button_renew_selected_pernamently       =   "Renew Selected Permanently";
$renew_selected_ondays                      =   "days";
$la_button_renew                            =   "Renew";
$la_validate_error_1						=	"Cannot connect to the server";
$la_validate_error_2						=	"Server returned an empty header";
$la_validate_error_3						=	"Page error code";
$la_validate_error_0						=	"Empty URL";
$la_lost_and_found_catid					=	"Category ID for \"Lost+Found\" links";
$la_catid_0									=	"Use zero to disable";
$la_check_lost_and_found_links				=	"Check for \"Lost + Found\" links";

#########################################################################################
#New for version 2.3.2

$la_premium_links                           =   "Editor Picks";
$la_diplay_picks_as_premiums                =   "Display Editor Picks separately in categories as Premium links?";
$la_limit_premiums                          =   "Limit Premium links";
$la_use_zero_for_all_premium                =   "use zero to display all";
$la_show_premiums_on_every_page             =   "Include Premium Links on every page";
$la_picks_inside_category_normal_listings   =   "Editor Picks inside category normal listing";
$la_pr_dont_display_editors_in_normals      =   "Don't display";
$la_pr_display_editors_in_normals_on_top    =   "Display at the top";
$la_pr_display_editors_in_normals_nr_order  =   "Display with regular sort order";
$la_pr_display_editors_in_normals_sp_templ  =   "Use a separate template";
$la_drop_random                             =   "Random";
$la_picks_in_other_templates                =   "Editor Picks in search results and other templates";

#########################################################################################
#New for version 2.3.3
$cykuh_credits						=	"This Nullified Edition was Presented to You by:";
$cykuh_header_reg					=	"WTN-WDYL Registry Hacks";
$cykuh_reg_domain					=	"Domain:";
$cykuh_first_name					=	"First Name:";
$cykuh_last_name					=	"Last Name:";
$cykuh_reg_info						=	"Here you can change the name the software is registered to and the registered domain.";
$cykuh_title_nullification				=	"Nullification";
$cykuh_null_info					=	"More useful hacks will be included in future nullified releases of In-link 2.";
$la_check_lost_and_found_cats				= 	"Check for \"Lost + Found\" categories";
$la_validation_hint					= 	"Please run one utility in a time if your database contains more then 50,000 links.";
$la_button_newvalidate					= 	"Revalidate all Links";
$la_button_revalidate					= 	"Revalidate Quarantined Links";
$la_button_validate_new_link				= 	"Validate not Checked Links";
$la_button_delete_all_dead				= 	"Delete all Dead Links";
$la_button_delete_all_selected				=	"Delete Selected";
$la_button_unmark_selected				=	"Unmark Selected";
$la_button_select_all_links				=	"Select all Links";
$la_button_select_all_dead_links			= 	"Select all Dead";
$la_button_select_all_suspect_links			= 	"Select all Suspects";
$la_button_validate_selected				= 	"Validate Selected";
$la_button_continue_validate				=	"Continue Validation of all Links";
$la_button_remove_valid_links				= 	"Un-Quarantine all Valid Links";
$la_displaying_dead_links				=	"Displaying ";
$la_displaying_dead_links1				=	"Suspects ";
$la_displaying_dead_links2				=	"Dead Links ";
$la_displaying_dead_links3				=	"for";
$la_displaying_dead_links4				=	"out of ";
$la_displaying_dead_links5				=	"Links ";
$la_displaying_dead_links6				=	"and";
$la_unmark_dead						=	"Unmark";
$la_mark_dead						=	"Mark";
$la_quarantine_disable					=	"Mark and Disable";
$la_quarantine_only					=	"Mark Only";
$la_button_quarantine					=	"Mark";
$la_quarantine_msg					=	"Are you sure you want to Mark the following link as a suspect -";
$la_not_validated_yet_mes				=	"Marked as Suspect!";
$la_quarantined						= 	"Marked";
$la_link_validated_ok					= 	"Valid link!";
$la_link_validated					= 	"Validated: ";
$la_link_marked						=	"Marked";
$la_continue_last_valadation				=	"Continue Links Validation from previous point?";
$la_drop_valid_time					=	"Validation date";
$la_drop_valid_code					=	"Validation code";
$la_drop_valid_status					=	"Validation status";
$la_site_map						=	"Site Map";
$la_site_map_num_columns				=	"Number of columns";
$la_site_map_num_columns_hint				=	"(Minimum 1, Maximum 5)";
$la_site_map_cats_levels_deep				=	"Number of Category Levels";
$la_site_map_cats_levels_deep_hint			=	"(use '-1' for all levels)";
$la_site_map_new_col_start_with_top_cat			=	"Start new colomn with Top level Category";
$la_use_dynamic_site_map				=	"Use dynamically generated map?";
$la_generate_static_html_site_map			=	"Generate static HTML site map";
$la_generate_static_html_site_map1			=	"(file: themes/default_theme/static_site_map.tpl)";
$la_generate_map_button					=	"Generate map";
$la_links_validation_type				=	"Links Validation";
$la_user_specific_validation				=	"Use admin-independent Link Validation";
$la_link_validation_settings				=	"Links Validation";
$la_link_validation_hints				=	"Prior to PHP 4.3, this function only worked on socket based streams. Since PHP 4.3, this function works for any stream that supports non-blocking mode (currently, regular files and socket streams). More information can be found <a href=\"http://www.php.net/manual/en/function.stream-set-blocking.php\">here</a>.";
$la_socket_blocking					=	"Type of sockets:";
$la_non_blocking					=	"Non-blocking";
$la_blocking						=	"Blocking";
$la_link_pending					=	"Pending";

?>
