<?php
//Read in config file
$admin = 1;
$configfile = "../includes/config.php";
include($configfile);

include_once ("../includes/links_lib.php");
include_once ("../includes/user_lib.php");

?>
<HTML>
<HEAD>
<TITLE><?php echo $la_pagetitle; ?></TITLE>
<META http-equiv="Content-Type" content="text/html; charset=<?php echo $la_char_set;?>">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<LINK rel="stylesheet" href="admin.css" type="text/css">
</HEAD>

<BODY bgcolor="#FFFFFF" text="#000000">
<TABLE width="100%" border="0" cellspacing="0" cellpadding="0">
  <TR> 
    <TD rowspan="2" width="0"><IMG src="images/icon2-.gif" width="32" height="32"></TD>
    <TD class="title" width="100%"><?php echo $la_nav11; ?></TD>
    <TD rowspan="2" width="0"><A href="help/manual.pdf"><IMG src="images/but1.gif" width="30" height="32" border="0"></A><A href="confirm.php?action=logout" target="_top"><IMG src="images/but2.gif" width="30" height="32" border="0"></A></TD>
  </TR>
  <TR> 
    <TD width="100%"><IMG src="images/line.gif" width="354" height="2"></TD>
  </TR>
</TABLE>
<BR>

<?php

function update_links($sub=0)
{	
	global $conn;
	
	$query="select cat_id from inl_cats where cat_sub=$sub and cat_pend=0";
	
	$retval["cats"]=0;
	$retval["links"]=0;

	//all childern and their links
	$rs = &$conn->Execute($query);

	while ($rs && !$rs->EOF) 
	{	
		$val=update_links($rs->fields[0]);

		$retval["cats"]  += $val["cats"]+1;
		$retval["links"] += $val["links"];

		$query="Update inl_cats set cat_cats=".$val["cats"].",cat_links=".$val["links"]." where cat_id = ".$rs->fields[0];
		$conn->Execute($query);

		$rs->MoveNext();
	}

	//its own links
	$query="select count(link_id) from inl_lc where cat_id=$sub and link_pend=0";
	$rs = &$conn->Execute($query);

	if ($rs && !$rs->EOF) 
		$retval["links"] += $rs->fields[0];
	
	return $retval; 
}

function check_lost_found_links($catID)
{
	global $conn;
	
	$count = 0;

	// GET CAT NAME
	$sql = "SELECT cat_name FROM inl_cats WHERE cat_id='$catID'";
	$rs = &$conn->Execute($sql);
	if (!$rs)
	{
		$ret [0] = 0;
		return $ret;
	}
	$ret[0] = $rs->fields[0];
	
	// DO THE LOST AN FOUND
	$sql = "SELECT t1.link_id, link_name FROM inl_links AS t1 LEFT JOIN inl_lc AS t2 ON t1.link_id=t2.link_id WHERE t2.link_id IS NULL GROUP BY link_id";
	$rs = &$conn->Execute($sql);
	while ($rs && !$rs->EOF)
	{
		$linkID = $rs->fields[0];
		$sql = "INSERT INTO inl_lc (link_id, cat_id, link_pend) VALUES ('$linkID', '$catID', '0')";
		$rs1 = &$conn->Execute($sql);
		$count = $rs1? $count+1 : $count;
		$rs->MoveNext();
	}
	$ret[1] = $count? $count : 0;
		 
	return $ret;
}

function CreateDeadCats($catIDs, $lostfound_cat_id)
{
	global $conn;		
	
	if (count($catIDs))
	{
		if (!$rootID = get_user_id("root"))
			$rootID = get_user_id("admin");
			
		foreach ($catIDs as $currID)
		{	
			
			$sql = "INSERT inl_cats (cat_id, cat_name, cat_sub, cat_vis, cat_date, cat_user) VALUES ('$currID', 'lostCat_".$currID."', '$lostfound_cat_id', '0', '".time()."', '".$rootID."')";
			if ($rs = &$conn->Execute($sql))
				$ret++;
			else
				echo "Couldn't create category: ".$sql."<BR><BR>";
		}
	}
	
	return $ret;
}

function CatsCleanUp($lostfound_cat_id)
{
	global $conn, $ses;	
	
	$sql = "SELECT cat_id, cat_sub FROM inl_cats ORDER BY cat_id DESC";
	if ($rs = &$conn->Execute($sql))
	{
		$allCatsArray = array();
		$DeadCatsArray = array();	
		
		while ($rs && !$rs->EOF)	
		{
			$curr = array('cat_id' => $rs->fields['cat_id'], 'cat_sub' => $rs->fields['cat_sub']);
			$allCatsArray[$rs->fields['cat_id']] = $curr;
			$Cats[$rs->fields['cat_id']] = (int) $rs->fields['cat_sub'];
			
			$rs->MoveNext();	
		}
	}
	
	if (is_array($allCatsArray) && count($allCatsArray))
	{
		reset($allCatsArray);		
		while (count($allCatsArray))	
		{
			if (is_array($currCat = array_pop($allCatsArray)))
			{
				$cur = $currCat['cat_id'];				
				
				while (true)
				{
					if (isset($Cats[$cur]) && array_key_exists($currCat['cat_id'], $Cats))
					{ 
						if ($Cats[$cur] != 0)
						{
							unset($allCatsArray[$cur]);

							$cur = $Cats[$cur];							
					
							reset($allCatsArray);
						}
						else
						{
							break;							
						}
					}
					else
					{											
						if (!in_array($cur, $DeadCatsArray))
						{
							array_push($DeadCatsArray, $cur);
						}
						break;
					}				
				}
												
			}						
		}
	}
	
	if (is_array($DeadCatsArray) && count($DeadCatsArray))
		$ret = CreateDeadCats($DeadCatsArray, $lostfound_cat_id);	
	
	return $ret;
}

function CustomFieldsCleanUp()
{
	global $conn;
		
	$sql = "SELECT t1.cust_id FROM inl_custom AS t1 LEFT JOIN inl_links AS t2 ON t2.link_cust=t1.cust_id LEFT JOIN inl_cats AS t3 ON t3.cat_cust=t1.cust_id LEFT JOIN inl_users AS t4 ON t4.user_cust=t1.cust_id WHERE t2.link_id IS NULL AND t3.cat_id IS NULL AND t4.user_id IS NULL";
	if ($rs = &$conn->Execute($sql))
	{
		while ($rs && !$rs->EOF)	
		{
			$custIDs.= $rs->fields['cust_id'].", ";
			$rs->MoveNext();	
		}
	}
	
	if (strlen($custIDs))
	{
		$custIDs = ereg_replace(", $", "", $custIDs);
		$sql = "DELETE FROM inl_custom WHERE cust_id IN ($custIDs)";
		$rs = $conn->Execute($sql);
	}
	return void;
}

if(strlen($submit)>0)
{	
	
	echo "<span class='text'><b>Please wait it may take a few minutes... </b><BR><BR></span>";
	
	if ($update_lost_found_cats && $lostfound_cat_id)
	{
		$res = CatsCleanUp($lostfound_cat_id);
		echo "<hr noshade size=1><span class='text'><b>Number of re-created categories ".$ret.". All placed under Lost+Found</b></span><hr noshade size=1>";					
	}	
	
	if ($update_lost_found_links && $lostfound_cat_id)
	{
		$result = check_lost_found_links($lostfound_cat_id);
		if ($result[0])
			echo "<hr noshade size=1><span class='text'><b>Number of the links moved to the ".$result[0].": ".$result[1]."</b></span><hr noshade size=1></body></html>"; 
		else
			echo "<hr noshade size=1><span class='text'><b>Category with ID ".$lostfound_cat_id." does not excist!</b></span><hr noshade size=1>";
	}
	
	if($update_links)
	{
		update_links(0); 
		
	## Added in In-link 2.3.3
		# Update/recount categories and links counter
		updateTotalCounters("links_cats"); 
		
		# Update/recount link Top values
		updateTopLinkValues();
		
		# Update/recount total link hits
		updateTotalLinkHitsSum();
	## End Added in In-link 2.3.3
		
		echo "<hr noshade size=1><span class='text'><b>Update links and category count: DONE</b></span><hr noshade size=1></body></html>";
		
	}
	
	// DO DB CLEAN UP (1 - by the empty links, 2 - by empty cat, 0 - both)
	doLinksCleanUp(1);
	CustomFieldsCleanUp();
	echo "</body></html>";
	
	exit();
}

?>
<FORM name="maintenance" method="post" action="data_cleanup.php?<?php
		if($sid && $session_get)
			echo "sid=$sid&";
	?>">
  <TABLE width="100%" border="0" cellspacing="0" cellpadding="2" class="tableborder">
  <TR> 
	<TD class="tabletitle" bgcolor="#666666"><?php echo $la_title_database_maintenance_cleanup; ?></TD>
  </TR>
  <TR> 
	<TD> 
	  	<TABLE width="100%" border="0" cellspacing="0" cellpadding="4">
	  	<tr> 
	    <td colspan="2" bgcolor="#FFFFFF" valign="middle"><span class="hint"><img src="images/mark.gif" width="16" height="16" align="absmiddle"><?php echo $la_validation_hint; ?></span> 
	    </td>
	  </tr>
		<TR> 
		  <TD valign="top" class="text" bgcolor="#F6F6F6"><?php echo $la_update_links_cats; ?></TD>
		  <TD bgcolor="#F6F6F6"> 
			<INPUT type="checkbox" name="update_links" class="text" value="1">
			</TD>
		</TR>
		<?php if ($lostfound_cat_id) {?>
		<TR bgcolor="#DEDEDE"> 
		  <TD valign="top" class="text" bgcolor="#DEDEDE"><?php echo $la_check_lost_and_found_links; ?></TD>
		  <TD bgcolor="#DEDEDE"> 
			<INPUT type="checkbox" name="update_lost_found_links" class="text" value="1">
			</TD>
		</TR>
		
		<TR bgcolor="#F6F6F6"> 
		  <TD valign="top" class="text" bgcolor="#F6F6F6"><?php echo $la_check_lost_and_found_cats; ?></TD>
		  <TD bgcolor="#F6F6F6"> 
			<INPUT type="checkbox" name="update_lost_found_cats" class="text" value="1">
			</TD>
		</TR>
		
		<?php } ?>
	  </TABLE>
	</TD>
  </TR>
</TABLE>
  <P>
	<INPUT type="submit" name="submit" value="<?php echo $la_button_proceed; ?>" class="button">
	<INPUT type="button" name="Submit3" value="<?php echo $la_button_cancel; ?>" class="button" onClick="history.back();">
  </P>
</FORM>
</BODY>
</HTML>