<?php
//Admin Pending Functions

// get values for number of pending
function editor_pending_cats_in_list()
{global $conn, $ses;

	$rs = &$conn->Execute("SELECT cat_id FROM inl_cats WHERE cat_user=".$ses["user_id"]); 
	if ($rs)
		$row = $rs->fields;
	if ($row)
	{
		foreach ($row as $ce)
		{
			$sub_cats = ereg_replace($ce.", ", "", $sub_cats);
			$sub_cats.= $ce.", ";
		}
		$sub_cats = ereg_replace(", $", "", $sub_cats);
	}
	return $sub_cats;

}

## Modified in In-link 2.3.3
function pendinginfo() 
{	
	global $conn, $plinks, $pcats, $pusers, $previews, $ses, $sql_type, $quarantined_links, $validate_table_name;
	
	## Pending Links
	if ($ses["user_perm"]==5) //editor
		$sql = "SELECT link_id FROM inl_lc LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id WHERE link_pend!=0 AND cat_user=".$ses["user_id"]." GROUP BY link_id";	
	else
		$sql = "SELECT t1.link_id FROM inl_lc AS t1 WHERE t1.link_pend!=0 GROUP BY t1.link_id";		
	
	$rs = &$conn->Execute($sql);
	$plinks = ($rs && !$rs->EOF)? $rs->RecordCount() : 0;
	
	## Pending Categories
	if($ses["user_perm"]==5) //editor
		$sql = "SELECT COUNT(cat_id) FROM inl_cats WHERE cat_pend!=0 and cat_sub IN (".editor_pending_cats_in_list().")";
	else
		$sql = "SELECT COUNT(cat_id) FROM inl_cats WHERE cat_pend=1";

	$rs = &$conn->Execute($sql);
	$pcats = ($rs && !$rs->EOF)? $rs->fields[0] : 0;	

	## Pending Users
	$sql = "SELECT COUNT(user_id) FROM inl_users WHERE user_pend=1";
	$rs = &$conn->Execute($sql);		
	$pusers = ($rs && !$rs->EOF)? $rs->fields[0] : 0;	
	
	## Pending Reviews
	if($ses_perm==5) //editor
		$sql = "SELECT COUNT(rev_id) FROM inl_reviews LEFT JOIN inl_lc ON inl_reviews.rev_link=inl_lc.link_id LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id WHERE rev_pend=1 AND cat_user=".$ses["user_id"];
	else
		$sql = "SELECT COUNT(rev_id) FROM inl_reviews WHERE rev_pend=1";
		
	$rs = &$conn->Execute($sql);		
	$previews = ($rs && !$rs->EOF)? $rs->fields[0] : 0;		

	## Quarantined Links	
	$quarantined_links = getTotalDeadLinks();
}
## End Modified

## Modified in In-link 2.3.3
function duplicate_links()
{	
	global $sql_type, $ses;
	
	if($sql_type=="mssql")
	{	
	    if($ses["user_perm"]==5)
	    {
			return "SELECT link_url, count(link_url) AS 'count' FROM inl_links LEFT JOIN inl_lc ON inl_links.link_id=inl_lc.link_id LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id WHERE link_url<>'http://' and link_url<>'' and inl_cats.cat_user=".$ses["user_id"]." GROUP BY link_url HAVING count(link_url)>1";
	    }
		else
		{
			return "SELECT link_url, count(link_url) AS 'count' FROM inl_links WHERE link_url<>'http://' and link_url<>'' GROUP BY link_url HAVING count(link_url)>1";
		}
	}
	else
	{	
	    if($ses["user_perm"]==5)
	    {
			return "SELECT link_url, count(link_url) AS count FROM inl_links LEFT JOIN inl_lc ON inl_links.link_id=inl_lc.link_id LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id WHERE link_url<>'http://' and link_url<>'' AND inl_cats.cat_user=".$ses["user_id"]." GROUP BY link_url HAVING count>1";
	    }
		else
		{
			return "SELECT link_url, count(link_url) AS count FROM inl_links WHERE link_url!='http://' AND link_url!='' GROUP BY link_url HAVING count>1";
		}
	}
	
	return $ret;
}
## End Modified in In-link 2.3.3

function printduplink($query)
{
	global $conn, $dups, $links, $la_no_links,$la_no_duplicate, $la_all_links_valid, $la_duplicate_links, $sid, $session_get, $start, $cachedData;

	if($sid && $session_get)
		$att_sid="sid=$sid&";

	$lim = 20;
	$start = $start? $start : 0;
			
	$rs = &$conn->Execute($query);
	$dups = ($rs && !$rs->EOF)? $rs->RecordCount() : 0;
	
	if (!$dups)
	{
	   $dups = 0;
	   $links = "<tr bgcolor='#999999' valign='middle'><td class='textTitle'><center>$la_all_links_valid</center></td></tr>";
	}
	else
	{
	    $dups_local = 0;
	    
	    $rs = &$conn->SelectLimit($query, $lim, $start);
	    if ($rs && !$rs->EOF)
	    {
	        
	        do
	        {
	        	 $row = $rs->fields;
			    	     
			     $sql = "SELECT t1.link_id, t1.link_url FROM inl_links AS t1 LEFT JOIN inl_lc AS t2 ON t1.link_id=t2.link_id WHERE t1.link_url='".$rs->fields['link_url']."' GROUP BY t2.link_id";
			     $rs1 = &$conn->Execute($sql);
			     $count = ($rs1 && !$rs1->EOF)? $rs1->RecordCount() : 0;
				
			     
			     if ($count > 1)
			     {
    			     $dups_local++;
    			   
    			     $links.= "<tr bgcolor='#999999' valign='middle'><td class='textTitle'> ( ".$count." ) $la_duplicate_links</td></tr>";
    			     $link_url = $row[0];
    			  
    			     $links .= "<tr bgcolor='#F6F6F6' valign='middle'><td class='text'><ul><li><input type=\"checkbox\" name=\"duplinks[$link_url]\"><b><a href='duplicatelinks.php?$att_sid"."dislink=1&url=$link_url'>$link_url</a></b></li><ul></td></tr>";
			     }
			     
			     $rs->MoveNext();
    		} 
    		while ($rs && !$rs->EOF);
    		
    		if (!$dups_local)
    		  $links = "<tr bgcolor='#999999' valign='middle'><td class='textTitle'><center>$la_all_links_valid</center></td></tr>";
	    }
	    $cachedData['duplicatelinks'] = $dups;
  	} 
}

## Modified in In-link 2.3.3
function checkdead()
{
	global $conn, $start, $query_ids, $check_redirect, $la_button_done , $la_button_cancel, $la_button_view, $urls, $sid, $session_get, $fresh, $la_validate_error_0, $ses, $fresh, $validate_table_name, $la_link_validated_ok, $fresh_all, $selected, $sql_type;

	// DROP ALL NON-EXCISTING TABLES (CLEAN UP)
	dropNonExcistingSessionsTables("inl_validate_", "validate");
	
	$selectLimit = 10;
	$tableName = $validate_table_name;
	
	if ($seleted && !$fresh)
	{
		$fresh = 0;
		$seleted = 1;
		$fresh_all = 0;
	}
	elseif ($fresh_all && $fresh)
	{
		$fresh = 1;
		$fresh_all = 1;		
		$seleted = 0;
	}
	elseif (!$fresh_all && $fresh)
	{
		$fresh = 1;
		$fresh_all = 0;	
		$seleted = 0;
	}	
	
	$start = !isset($start)? 0 : $start;
	
	if ($fresh)
	{	
		## Drop and Create new validation table
		if (($start < $selectLimit))
		{
			if ($fresh_all)
				ValidationTable("recreate");
			else
			{
				ValidationTable("reuse");
				## If trying to continue from last place
				if (!$fresh_all)
				{
					$query = "SELECT code_id FROM $tableName WHERE link_id='0'";
					$rs = &$conn->Execute($query);
					$start = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
					$fresh_all = 1;
				}							        			
			}
		}
		else
		{			
			$sql = "SELECT link_id FROM ".$tableName;
			if (!$rs = &$conn->Execute($sql))
				ValidationTable();				
		}
		
		$query = "SELECT COUNT(link_id) AS count FROM inl_links ";
		$rs = &$conn->Execute($query);
		$total = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
				
		## Empty existing links
		//quarantine_functions("cleanup");
		
		$query = "UPDATE $tableName SET code_id='$start' WHERE link_id='0'";
		$rs = &$conn->Execute($query);
		
		if ($sql_type == "mssql")
			$add_sql = ", t1.link_url, status";
			
		$query = "SELECT t1.link_id, t1.link_url, status FROM inl_links AS t1 LEFT JOIN inl_lc AS t2 ON t2.link_id=t1.link_id LEFT JOIN $tableName AS t3 ON t3.link_id=t1.link_id WHERE t2.link_pend='0' GROUP BY t1.link_id$add_sql ORDER BY t1.link_id";				
	}
	else
	{				
		$add_cond = $selected? "AND t2.selected='1'" : "";
		
		## Get total number of links
		$query = "SELECT COUNT(t1.link_id) FROM $tableName AS t2 LEFT JOIN inl_links AS t1 ON t2.link_id=t1.link_id WHERE t2.link_id!='0' AND t1.link_id IS NOT NULL $add_cond";
		$rs = &$conn->Execute($query);
		$total = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
		
		$query = "SELECT t1.link_id, t1.link_url, status FROM $tableName AS t2 LEFT JOIN inl_links AS t1 ON t2.link_id=t1.link_id WHERE t2.link_id!='0' AND t1.link_id IS NOT NULL $add_cond ORDER BY t2.valid_time ASC";
			
	}
	
	$att_fresh = "&fresh=$fresh&fresh_all=$fresh_all&seleted=$seleted";
	
	$rs = &$conn->SelectLimit($query, $selectLimit, $start);
	$start = $start? (int)$start+$selectLimit : $selectLimit;
	$att_sid = ($sid && $session_get)? "sid=$sid&" : "";	 
	
	// echo "$query, $selectLimit, $start, TOTAL: $total";	
	//die();	
    
	while ($rs && !$rs->EOF) 
	{	
		$message = array();
	    
	    $link_old = isset($rs->fields['status'])? 1 : 0;
	    $link_url = $rs->fields['link_url'];
	    $link_id = $rs->fields['link_id'];
	    
		if(($rs->fields[1] == "http://") || ($rs->fields[1] == ""))
		{
			if($urls == "urls")
			{
				$fail = 1;
				$message[0] = 0;
			    $message[1] = 4; 
			    $message[2] = $la_validate_error_0; 
			}
			else
    		    $fail = 0;   			
		}
		else
		{	
			$message = requestServerAttantion($rs->fields[1]);
			$fail = $message[0]? 0 : 1;
		}
					
		if($fail == 1)
		{
			if ($link_old && !is_null($link_old))
			{				
				$sql = "UPDATE $tableName SET status='0', message='".$message[2]."', code_id='".$message[1]."', valid_time='".time()."' WHERE link_id='$link_id'";
			}
			else
				$sql = "INSERT INTO $tableName (link_id, message, code_id, status, valid_time) VALUES (' $link_id', '".$message[2]."', '".$message[1]."', '0', '".time()."')";			
		}
		elseif ($link_old && !is_null($link_old)) 
		{			
			$sql = "DELETE FROM $tableName WHERE link_id='$link_id'";
		}
		else
			$sql = "";	
		
		
		if (strlen($sql))
			$rs1 = &$conn->Execute($sql);		
		
		$cur = $start;				
		$rs->MoveNext();
	}
	
	
	
	if(($total <= $cur) ||($total == 0))
	{
			$check_done="<font color='#A0A0E0'><b><center>100%</center></b></font>
			  <table border='1' cellspacing='0' width='100%' bordercolor='#C0C0C0'>
       		 <tr>
         			 <td width='100%' bgcolor='#A0A0E0'>&nbsp;</td>
        		</tr>
      	</table><center><input type='button' value='$la_button_done' name='done' class='button'></center>";
		$check_redirect="
			<script language=\"javascript\">
			<!-- 		
			
				location.href=\"linksvalidate.php?$att_sid"."display=Display&start=0\";			
		
			//-->
			</script>";	
		
		echo "location.href=\"linksvalidate.php?$att_sid"."display=Display&start=0";	
		
		return $check_done;
	}
	else
	{
		$PERCENT=100*$cur/$total;
		$PERCENT=number_format($PERCENT,1);
		$t=100-$PERCENT;
		$p=$PERCENT;
		$t=number_format($t,0);
		$p=number_format($p,0);
		$check_processing= "<div align=\"center\"><font color='#A0A0E0'><b>".$PERCENT."%</b></font></div>
  			<table border='1' cellspacing='0' width='100%' bordercolor='#C0C0C0'>
      	  <tr>
      	    <td width='".$PERCENT."%' bgcolor='#A0A0E0'>&nbsp;</td>
      	    <td width='".$t."%'>&nbsp;</td>
      	  </tr>
      	</table><center><input type='button' value='$la_button_cancel' name='cancel' class='button' onClick=location.href=\"pending.php\"> <input type='button' value='$la_button_view' name='view' class='button' onClick=location.href=\"linksvalidate.php?".insert_sid()."&display=Display&\"></center>";
		
		global $validate_redirect;			
		$check_redirect="
			<script language=\"javascript\">
			<!--		
				window.setTimeout('location.href=\"linksvalidate.php?".insert_sid()."&start=$start&urls=$urls&$att_fresh&display=\"', 100);
					
			//-->
			</script>";				
		
		
		return $check_processing;
	}	
}

function url_valid($url)
{
	global $la_validate_error_3, $la_validate_error_2, $la_validate_error_1, $blocking_sockets;

   if(!ereg("^http://",$url) && !ereg("^https://",$url))
		$url="http://".$url;	

	$urlArray = parse_url($url);
   
    if (!$urlArray[port])
    { 
		if ($urlArray[scheme] == 'http') { $urlArray[port] = 80; } 
		elseif ($urlArray[scheme] == 'https') { $urlArray[port] = 443; } 
		elseif ($urlArray[scheme] == 'ftp') { $urlArray[port] = 21; } 
    } 

	$urlArray[path] = !strlen($urlArray[path])? '/' : $urlArray[path];

	$errno = "";
	$errstr = "";
	$ret = Array();
	$line = "";
	
	$fp = @fsockopen ($urlArray[host], $urlArray[port], &$errno, &$errstr, 5);
	
	$sstatus = "OK";  
    	
	if (!$fp)
	{
	    $ret[0] = 0;
	    $ret[1] = 5;
        $ret[2] = $la_validate_error_1;
        return $ret;
	}

	$req = sprintf("GET %s HTTP/1.0\r\nHost: %s\r\nConnection: Close\r\n\r\n", $urlArray[path], $urlArray[host]);
		
	set_socket_blocking($fp, $blocking_sockets);
	
	fputs($fp, $req, strlen($req)); 
    
	if (!feof($fp)) 
    { 
    	## Give 0.2 sec delay if server returned empty line
    	if (!strlen($line = fread($fp, 1024)))
    	{
	   		usleep(200);
	   		if (!feof($fp)) 
	   			$line = fread($fp, 1024);
	   		else
	   		{
	   			$ret[0] = 0;
		    	$ret[1] = 2;
		    	$ret[2] = $la_validate_error_2.": $line";
		    	fclose($fp);
    	   		return $ret;
	   		}
    	}  	
	   		
    	if(eregi("HTTP/1.(.) ([0-9]*) (.*)", $line, $parts ) ) 
    	{ 
    	   $result = ($parts[2] < "400")? 1 : 0; 
    			
    	   if ($result)
    	   {
    	       $ret[0] = 1;
    	       $ret[1] = "";
    		   $ret[2] = "";    
    	   }
           else
           {
    		   $ret[0] = 0;
    	       $ret[1] = 1;
    		   $ret[2] = $la_validate_error_3.": ".$parts[2];
           }
    	 
    	   fclose($fp);
    	   return $ret;
    	}
        else 
        {        		
           $ret[0] = 0;
    	   $ret[1] = 2;
    	   $ret[2] = $la_validate_error_2.": $line";    	
        }
   	}
   	else
   	{
   		 $ret[0] = 0;
    	 $ret[1] = 2;
    	 $ret[2] = $la_validate_error_2.": Server connection is too slow";		
   	}
  
	fclose($fp);
	return $ret;
}
## End Modified

function requestServerAttantion($url)
{
    global $checkLimit;
    
    $checkLimit = 1;
    $ret = array();
    $i = 0; 
      
    while ($i < $checkLimit)
    {
        $ret = url_valid($url);
        if ($ret[0]>0)
            return $ret;
        $i++;
    }  
    
    return $ret;    
}

function pagenavdead($cat, $query, $file, $start, $ar, $total) {
	global $conn, $pagenav, $lim, $la_go_to_page, $sid, $session_get;

	if($sid && $session_get)
		$att_sid="sid=$sid&";
	$pagenav = "";	
	if (!$start) {
		$start = "0";
  	}
	if ($ar) {
		$more ="";
		while (list ($varname, $varval) = each ($ar)) {
			$more .= "&$varname=$varval";
		}

		if (($id)&&($type)) {$more = "&id=$id&type=$type";}
	}

	$result = &$conn->Execute($query);
	if ($total > $lim) {
	  	$pagenav = $la_go_to_page;
		if ($start >=(10 * $lim)) {
			$startpage = floor($start/$lim);
			if($startpage){$st2 = $startpage * $lim-9*$lim;$pagenav .= "<a href=\"$file.php?$att_sid"."cat=$cat&start=$st2$more\"><<</a>";}
		}
		if ($startpage) {
			$num = $startpage * $lim;
			$pagenum = $startpage;
		} else {
			$num = "0";
  			$pagenum = "1";
		}
		$pagelinknum = 1;
		if ($total > $lim) {
    			while (($num < $total) && ($pagelinknum <= 10)) {
      			$endnum = $num + $lim;
      			if ($num == $start) {
      				$pagenav .= "$pagenum  ";
      			} else {
      			$pagenav .= "<a href=\"$file.php?$att_sid"."cat=$cat&start=$num$more\">$pagenum</a>  ";
      			}
      			$num = $num + $lim;
      			$pagenum++;
				$pagelinknum++;
      		}
			if (($pagelinknum > 10) && ($num < $total)) {
				#$startpage = floor($start/$lim);
				#$st2 = ($startpage + 10) * $lim;
				$pagenav .= "<a href=\"$file.php?$att_sid"."cat=$cat&start=$num$more\">>></a>";
			}
		}
	}
}

## Modified in In-link 2.3.3
function getTotalDeadLinks($type = null)
{
    global $conn, $validate_table_name;
    
    if (is_null($type))
    	$att_exc = " WHERE t1.link_id!='0' AND t2.link_id IS NOT NULL";
    elseif ($type == "marked")	
    	$att_exc = " WHERE t1.link_id!='0' AND t2.link_id IS NOT NULL AND t1.status='2'";
    elseif ($type == "dead")		
    	$att_exc = " WHERE t1.link_id!='0' AND t2.link_id IS NOT NULL AND t1.status='0'";	
    else
    	$att_exc = " WHERE t2.link_id IS NOT NULL";	  
    	
    $sql = "SELECT COUNT(t1.link_id) FROM ".$validate_table_name." AS t1 LEFT JOIN inl_links AS t2 ON t2.link_id=t1.link_id".$att_exc;
    $rs = &$conn->Execute($sql);
    $ret = ($rs && !$rs->EOF && $rs->fields[0])? $rs->fields[0] : 0;
    
    return $ret;   
}
## End Modified

## Added in In-link 2.3.3
function getCurrentStatus()
{
	global $conn, $validate_table_name;
	
	$sql = "SELECT code_id FROM $validate_table_name WHERE link_id='0'";
	$rs = &$conn->Execute($sql);
    $ret = ($rs && !$rs->EOF && ($rs->fields[0]>0))? 1 : 0;
    
	return $ret;
}

function pagenav_validation($cat, $query, $file, $start, $ar) 
{	
	global $conn, $pagenav, $lim, $lu_go_to_page,$la_go_to_page, $admin, $sid, $session_get, $duplicatemail, $act, $cachedData, $t, $validation;
		
	
	if ($act)
		$act_attacht = "&act=$act";
	else 
		$act_attacht = "";

	$query = ereg_replace("@\!", "&", $query);
	$pagenav = "";	
	
	if($admin==1)
	{
		$back="";
		$go_to="$la_go_to_page ";
	}
	else
	{
		$go_to="$lu_go_to_page ";
		$back="../../";
	}
	if (!$start) {
		$start = "0";
  	}
	if ($ar)
	{
		$more ="";
		while (list ($varname, $varval) = each ($ar))
		{
		    $more.= "&$varname=$varval";
		}
		if (($id) && ($type)) 
			$more = "&id=$id&type=$type";
	}
	
	settype($start,"integer");
	settype($lim,"integer");

	
	$total = insert_validate_link_count();
	   	
	if ($total > $lim)
	{
	  	$pagenav = $go_to."&nbsp;&nbsp;";
	  	
	  	######## BACK PAGE #######	  	
	  	if ($start>0)
		{
			$backpage = $start - $lim; 	  	
			// $pagenav.= " <a href=\"$back$file.php?$att_sid"."cat=$cat&start=$backpage$more".$dup_email.$act_attacht."\">Back Page</a>&nbsp;&nbsp;"; 
			$pagenav.= " <a href=\"javascript:PageNav('$backpage', 'form2')\">Back Page</a>&nbsp;&nbsp;"; 
		}
	  	##########################
	  	
		if ($start >=(10 * $lim))
		{
			$startpage = floor($start/$lim);
			if($startpage)
			{
				$st2 = $startpage * $lim-9*$lim;
				$pagenav .= "<a href=\"javascript:PageNav('$st2', 'form2')\"><<</a>&nbsp;";
			}
		}
		if ($startpage)
		{
			$num = $startpage * $lim;
			$pagenum = ($startpage+1);
		} 
		else
		{
			$num = "0";
  			$pagenum = "1";
		}
		$pagelinknum = 1;
		
		
		if ($total > $lim) 
		{
    			while (($num < $total) && ($pagelinknum <= 10))
				{
      				$endnum = $num + $lim;
      				if ($num == $start)
						$pagenav.= "<SPAN class=\"put_class_here\">[$pagenum]</SPAN>&nbsp;&nbsp;";
      				else
      					$pagenav.= "<a href=\"javascript:PageNav('$num', 'form2')\">$pagenum</a>&nbsp;&nbsp;"; 
		      		$num = $num + $lim;
      				$pagenum++;
					$pagelinknum++;
      			}
				if (($pagelinknum > 10) && ($num < $total))
				{
					$pagenav .= "<a href=\"javascript:PageNav('$num', 'form2')\">>></a>&nbsp;";			
				}
				
				######## NEXT PAGE #######					
				if (($start+$lim) < $total)
				{
					$nextpage = $start + $lim; 
					$pagenav .= "&nbsp;&nbsp;<a href=\"javascript:PageNav('$nextpage', 'form2')\">Next Page</a>";
				}
				##########################
				
		}		
	}
}
## End Added

?>