<?php

	
	//Turns off the magic quotes
	@set_magic_quotes_runtime (0);
	// Overrides GPC variables 

	//load default english language variables
	if ($admin == 1)
	{	
	    if(!file_exists("$language_path/english/language_admin.php"))	
		{	error("English language files are required. Failed to load admin language file: $language_path/english/language_admin.php",0); //fatal;
			die();
		}
		else
			include_once("$language_path/english/language_admin.php");
	}
	else
	{	
	    if(!file_exists("$language_path/english/language.php"))	
		{	error("English language files are required. Failed to load language file: $language_path/english/language.php",0); //fatal;
			die();
		}
		else
			include_once("$language_path/english/language.php");
	}
	
	//open DB connection
	$conn=&ADONewConnection($sql_type);
	$conn->Connect($sql_server, $sql_user, $sql_pass, $sql_db);	
	
	if(!$conn)
	{	error("Database connection failed. DB Type: $sql_type, DB Server: $sql_server, DB User: $sql_user, DB Name: $sql_db",0); //fatal;
		error($conn->ErrorMsg(),0);
		die();
	}
	
	## Added in In-link 2.3.3
	$ADODB_FETCH_MODE = ADODB_FETCH_BOTH;	
	## End Added
	
	//initialize all variables
	$rs = &$conn->Execute("SELECT name, value FROM inl_config");
	while ($rs && !$rs->EOF) 
	{	
		$c_name = $rs->fields[0];
	    $c_value = $rs->fields[1];
		$$c_name = $c_value;
		$rs->MoveNext();
	}	
	
	## Added in In-link 2.3.3
	if($session_cookie)
	{		
		if (!empty($_COOKIE[$_cookie_name]))
			$sid = $_COOKIE[$_cookie_name];
		elseif ($session_get)
			$sid = !empty($_GET['sid'])? $_GET['sid'] : $_POST['sid'];		
	}	
	## End Added
	
	if($pconnect)
	{
		$conn->Close();
		$conn=&ADONewConnection($sql_type);
		$conn->PConnect($sql_server, $sql_user, $sql_pass, $sql_db);
	}
	
	if ($having)
	{
		$SearchLogData = Array();
		getSearchVars($having);		
	}

	## Session handling
	if($sid)
	{
		$test = load_session($sid);				
	}
	
	//save browsing options
	$i_change=false;

	if($cat_sort_c && $cat_sort_c != $ses["cat_sort"])
	{	$ses["cat_sort"]=$cat_sort_c;
		$i_change=true;
	}
	elseif(!$ses["cat_sort"])
		$ses["cat_sort"]=$cat_sort; //default

	if($cat_order_c && $cat_order_c != $ses["cat_order"])
	{	$ses["cat_order"]=$cat_order_c;
		$i_change=true;
	}
	elseif(!$ses["cat_order"])
		$ses["cat_order"]=$cat_order; //default

    // LINK ORDER SELECTION (CHECKING SORT BY SEARCH RELEVANCE)
	if ((($t == "search_links") || ($t == "display_link_search")) && $extended_search && ($SearchLogData['search_type'] == 1))
    {
      	if ($force_link_relevance_sort && (!strlen($ses["link_order"]) || ($link_order_c == "link_relevance") || !strlen($link_order_c)))
      	   $ses["link_order"] = $link_order_c = "link_relevance";
      	elseif(strlen($link_order_c))
    	   $ses["link_order"] = $link_order_c;   	
        else
           $ses["link_order"] = $link_order;
                 
        // SORT
    	if ($force_link_relevance_sort && (!strlen($ses["link_sort"]) || ($link_sort_c == "desc") || !strlen($link_sort_c)))
    	   $ses["link_sort"] = $link_sort_c = "desc";
    	elseif(strlen($link_order_c))
    	   $ses["link_sort"] = $link_sort_c;   	
        else
           $ses["link_sort"] = $link_sort;
            
        $i_change = true;
    }
    else
    {
    	if($link_order_c && ($link_order_c != $ses["link_order"]))
           $ses["link_order"] = $link_order_c;
    	elseif(!$ses["link_order"] || ($ses["link_order"] == "link_relevance"))
    	   $ses["link_order"] = $link_order; //default
    	          
    	// SORTING ORDER
    	if($link_sort_c && ($link_sort_c != $ses["link_sort"]))
      		$ses["link_sort"] = $link_sort_c;
      	elseif(!$ses["link_sort"] || ($ses["link_order"] == "link_relevance"))
    		$ses["link_sort"] = $link_sort; //default
    	
    	$i_change = true;
    	// END SORTING ORDER
    }
    // END
	
	if($num_results && $num_results != $ses["num_res"])
	{	$ses["num_res"]=$num_results;
		$i_change=true;
	}
	elseif(!$ses["num_res"])
		$ses["num_res"]=$lim; //default

	if($inl_language=="default")
		$inl_language=$language;

	if($inl_language && $inl_language!=$ses["lang"])
	{	$ses["lang"]=$inl_language;
		$i_change=true;
	}
	elseif(!$ses["lang"])
		$ses["lang"]=$language; //default

	if($inl_theme=="default")
		$inl_theme=$theme;

	if($inl_theme && $inl_theme!=$ses["theme"])
	{	$ses["theme"]=$inl_theme;
		$i_change=true;
	}
	elseif(!$ses["theme"])
		$ses["theme"]=$theme; //default
		
	if($sid)
	{	
		if($i_change) //save new options
		{	if(!save_session($sid))
			{	error("Database Error",0); //fatal;
				die();
			}
		}
		else
			refresh_session($sid);
	}
	elseif($i_change)
	{	
		if(!$sid=init_session())
		{	error("Failed to create a session",0); //fatal;
			error($conn->ErrorMsg(),0); //fatal;
			die();
		}
		if(!save_session($sid))
		{	error("Database Error",0); //fatal;
			error($conn->ErrorMsg(),0); //fatal;
			die();
		}
		
	}
	
	//load language variables if not enlgish
	if($ses["lang"]!="english")
	{	
		if ($admin == 1)
		{	if(!file_exists("$language_path/".$ses["lang"]."/language_admin.php"))	
			{	error("Failed to load admin language file: $language_path/".$ses["lang"]."/language_admin.php",0); //fatal;
				die();
			}
			else
				include_once("$language_path/".$ses["lang"]."/language_admin.php");
		}
		else
		{	if(!file_exists("$language_path/".$ses["lang"]."/language.php"))	
			{	error("Failed to load language file: $language_path/".$ses["lang"]."/language.php",0); //fatal;
				die();
			}
			else
				include_once("$language_path/".$ses["lang"]."/language.php");
		}
	}
		
	## Modified in In-link 2.3.3
	###############################################
	// DROP TEMPORARLY TABLE FOR EXTENDED_SEARCH
	if (($extended_search == 1) && ($table!="link3") && ($table!="links3") && ($t != "details"))
	{
	   if ($sid && (!$having || $_fresh=="drop"))
	       $rs = &$conn->Execute("DROP TABLE inl_$sid");
	}
	###############################################	
	
	## Added in In-link 2.3.3
	$toprate = $min_top_link_rating;
	$tophits = $min_top_link_hits;
	
	## Select Name Validation Table 
	if (!$static_validate_table)
	{
		$root_user_data = get_root_user();
		$validate_table_name = "inl_validate_".$root_user_data['user_id'];
	}
	else
	{
		$validate_table_name = "inl_validate_".$ses['user_id'];
	}
	## End Added
			
	//check login for admin
	//admin but not the login screen
	if($admin && ($thisfile != "login") && ($thisfile != "index")) 
	{		
		if ($ses["user_perm"]==5)
		{
			if (!ereg($thisfile, $file_list))
			{
				error($la_login_expired,0);
				echo "<br>$la_click_to_login1 <a href='http://$server$filepath"."admin/login.php' target='_top'> $la_click_to_login2 </a> $la_click_to_login3";
				die();	
			}
		}
		elseif (($ses["user_perm"]>2) || (!$ses["user_perm"]))
		{
			error($la_login_expired,0);
			echo "<br>$la_click_to_login1 <a href='http://$server$filepath"."admin/login.php' target='_top'> $la_click_to_login2 </a> $la_click_to_login3";
			die();	
				
		}	
	}
	
?>