<?php

/*	
    In-link Functions Library Version 2.3.2
	Miscellaneous Functions
	Included in config.php, required for all scripts

	Last updated 11/03/03
*/

function do_search_lighting($tag_name, $in_data)
{	
	global $conn, $having, $high_lighting_tag1, $high_lighting_tag2, $field_name, $field_data, 
	$SearchLogData, $AllKeyWords;

	$replace_this_tag = false;
	$out_data = "";

	// DON"T DO SECOND SELECT IF DONE IT BEFORE
	if (!$SearchLogData['act'] || !$SearchLogData['search_type'] || !$SearchLogData['search_word'])
	{
		$que = "SELECT log_keyword, log_search  FROM inl_search_log where log_id='$having'";
		$rs = &$conn->Execute($que);
		if ($rs && !$rs->EOF) 
		{
			$h = stripslashes($rs->fields[0]);
			$search_type = $rs->fields[1];
			$SearchLogData['search_type'] = $search_type;
			$SearchLogData['search_word'] = $h;

		}
	}
	else
	{
		$h = $SearchLogData['search_word'];
		$search_type = $SearchLogData['search_type'];

	}

	if ($search_type == 1)	
	{
		
		if (!count($AllKeyWords["normal"]) && !count($AllKeyWords["required"]))
			$AllKeyWords = GetKeywords($h);
		$key = $AllKeyWords;


		$where = do_search_where();

		
		if (in_array($tag_name, $where))
		{
			foreach ($key["normal"] as $Norm)
			{
				$Norm = str_replace("/", "\/", $Norm);
				if ($in_data = preg_replace("/($Norm)/Ui","$high_lighting_tag1\\1$high_lighting_tag2", $in_data))
					$out_data = $in_data;
			}
		
			foreach ($key["required"] as $Requr)
			{
				$Requr = str_replace("/", "\/", $Requr);
				if ($in_data = preg_replace("/($Requr)/Ui","$high_lighting_tag1\\1$high_lighting_tag2", $in_data))
					$out_data = $in_data;
			}
		
		}

	}
	elseif ($search_type == 2)
	{
		avd_get_keywords($h);
		foreach($field_name as $k => $w)
			if ($tag_name == $w)
			{
				$out_data = @eregi_replace($field_data[$k], $high_lighting_tag1.$field_data[$k].$high_lighting_tag2, $in_data);
				break;
			}
	}

	if (strlen($out_data)<1)
		$out_data = $in_data;

	return $out_data; 
}

function do_search_where()
{	
    global $do_link_name, $do_link_desc, $do_link_url, $do_link_image, $do_link_cust1, $do_link_cust2,	$do_link_cust3, $do_link_cust4, $do_link_cust5, $do_link_cust6, 
    $link_name_value, $link_desc_value, $link_url_value, $link_image_value, $link_cust1_value, $link_cust2_value, $link_cust3_value, $link_cust4_value, $link_cust5_value, $link_cust6_value, $simple_search_values;
    
	$simple_search_array   = array();
	$simple_search_values  = array(); 
	
	
	if ($do_link_name) { $simple_search_array[] = "link_name"; $simple_search_values[] = $link_name_value; }
	if ($do_link_desc) { $simple_search_array[] = "link_desc"; $simple_search_values[] = $link_desc_value; }
	if ($do_link_url)  { $simple_search_array[] = "link_url"; $simple_search_values[] = $link_url_value; }
	if ($do_link_image){ $simple_search_array[] = "link_image";$simple_search_values[] = $link_image_value;}
	if ($do_link_cust1) { $simple_search_array[] = "cust1"; $simple_search_values[] = $link_cust1_value; }
	if ($do_link_cust2) { $simple_search_array[] = "cust2"; $simple_search_values[] = $link_cust2_value; }
	if ($do_link_cust3) { $simple_search_array[] = "cust3"; $simple_search_values[] = $link_cust3_value; }
	if ($do_link_cust4) { $simple_search_array[] = "cust4"; $simple_search_values[] = $link_cust4_value; }
	if ($do_link_cust5) { $simple_search_array[] = "cust5"; $simple_search_values[] = $link_cust5_value; }
	if ($do_link_cust6) { $simple_search_array[] = "cust6"; $simple_search_values[] = $link_cust6_value; }
	
	if ($do_link_cust7) { $simple_search_array[] = "cust7"; $simple_search_values[] = $link_cust7_value; }
	if ($do_link_cust8) { $simple_search_array[] = "cust8"; $simple_search_values[] = $link_cust8_value; }
	if ($do_link_cust9) { $simple_search_array[] = "cust9"; $simple_search_values[] = $link_cust9_value; }
	if ($do_link_cust10) { $simple_search_array[] = "cust10"; $simple_search_values[] = $link_cust10_value; }
	if ($do_link_cust11) { $simple_search_array[] = "cust11"; $simple_search_values[] = $link_cust11_value; }
	if ($do_link_cust12) { $simple_search_array[] = "cust12"; $simple_search_values[] = $link_cust12_value; }
	if ($do_link_cust13) { $simple_search_array[] = "cust13"; $simple_search_values[] = $link_cust13_value; }
	if ($do_link_cust14) { $simple_search_array[] = "cust14"; $simple_search_values[] = $link_cust14_value; }
	if ($do_link_cust15) { $simple_search_array[] = "cust15"; $simple_search_values[] = $link_cust15_value; }
	if ($do_link_cust16) { $simple_search_array[] = "cust16"; $simple_search_values[] = $link_cust16_value; }
	if ($do_link_cust17) { $simple_search_array[] = "cust17"; $simple_search_values[] = $link_cust17_value; }
	if ($do_link_cust18) { $simple_search_array[] = "cust18"; $simple_search_values[] = $link_cust18_value; }
	if ($do_link_cust19) { $simple_search_array[] = "cust19"; $simple_search_values[] = $link_cust19_value; }
	if ($do_link_cust20) { $simple_search_array[] = "cust20"; $simple_search_values[] = $link_cust20_value; }
	if ($do_link_cust21) { $simple_search_array[] = "cust21"; $simple_search_values[] = $link_cust21_value; }
	
	return $simple_search_array;
}

function do_search_where_cats()
{	
    global $do_cat_name, $do_cat_desc, $do_cat_image, $do_cat_cust1, $do_cat_cust2,
			$do_cat_cust3, $do_cat_cust4, $do_cat_cust5, $do_cat_cust6;
	$j = 0;
	if ($do_cat_name)
	{	$simple_search_array[$j] = "cat_name";	$j++;	}
	if ($do_cat_desc)
	{	$simple_search_array[$j] = "cat_desc";	$j++;	}
	if ($do_cat_image)
	{	$simple_search_array[$j] = "cat_image";	$j++;	}
	if ($do_cat_cust1) 
	{	$simple_search_array[$j] = "cust1";	$j++;	}
	if ($do_cat_cust2) 
	{	$simple_search_array[$j] = "cust2";	$j++;	}
	if ($do_cat_cust3) 
	{	$simple_search_array[$j] = "cust3";	$j++;	}
	if ($do_cat_cust4) 
	{	$simple_search_array[$j] = "cust4";	$j++;	}
	if ($do_cat_cust5) 
	{	$simple_search_array[$j] = "cust5";	$j++;	}
	if ($do_cat_cust6) 
	{	$simple_search_array[$j] = "cust6";	$j++;	}
	
	return $simple_search_array;
}

## This function won't be used in 2.3.3
function MaxSearchHitsRating($table)
{
    global $conn, $MaxSearchHitsRatingValues;
    
    $MaxSearchHitsRatingValues = array(0, 0);
    
    // GET VALUE HITS OF TOP HITS & LINK
	$sql = "SELECT MAX(t1.hits), MAX(t1.rating), 0 AS empty_value FROM ".$table." AS t1 GROUP BY empty_value";
	$rs = &$conn->Execute($sql);

	if ($rs && !$rs->EOF)
	   $MaxSearchHitsRatingValues = $rs->fields;
}
## End This function 

## Modified in In-link 2.3.3
function getRelevanceFormula($simple_search, $keywords)
{
	global $conn, $link_hits_relevance, $keywords_relevance, $link_rating_relevance, $MaxSearchKeywordsRelevance, $MaxSearchHitsRatingValues, $sid, $top_link_rating, $top_link_hits;

	//INIT VARs
	$SearchRelevance	= "";
	$LinkHitsImportance = "";
	$SearchRelevance	= "";
	$MaxLinkHits		= 0;
  
	$IFStatement = GetIFStatement($simple_search, $keywords);
	
	   // GET KEYWORDS IMPORTANCE PART
	if ($keywords_relevance && $MaxSearchKeywordsRelevance && strlen($IFStatement))
	{
		$SearchRelevance = "((".($keywords_relevance/10)."*((".$IFStatement.")/".$MaxSearchKeywordsRelevance."))";
		$ret = $SearchRelevance;
	}
	else
		$ret = "(";
		
	// GET LINK HITS IMPORTANCE PART
	if ($link_hits_relevance)
	{
		$LinkHitsImportance = ($top_link_hits > 0)? "(".($link_hits_relevance/10)."*(link_hits/".$top_link_hits."))" : "";		
		$ret.= (strlen($ret)>1)? "+".$LinkHitsImportance : $LinkHitsImportance;	   
	}	

	// GET LINK RATING IMPORTANCE PART
	if ($link_rating_relevance)
	{		 
		$LinkRatingImportance = ($top_link_rating > 0)? "(".($link_rating_relevance/10)."*(link_rating/".$top_link_rating.")))" : "";
		$ret.= strlen($ret)? "+".$LinkRatingImportance : "";		
	}

	return $ret;	
}

## Modified in In-link 2.3.3
function GetIFStatement($fields, $keywords)
{ 
    global $simple_search_values, $MaxSearchKeywordsRelevance, $link_importanceForRequired_fields, $sql_type;
    
    settype($total, "integer");
    
    foreach ($fields as $cur => $val)
    {
        if (count($keywords['normal']))
        {
            foreach ($keywords['normal'] as $cur1 => $val1)
            {
                $value = $simple_search_values[$cur];
                
                if ($sql_type == "mssql")
                {
                	$ret.= " (CASE WHEN PATINDEX('%$val1%', $val) > 0 THEN $value ELSE 0 END) +";
                }
                else
                	$ret.= " (IF ($val LIKE '%$val1%', ".$value.", 0)) +";
                	
                $total = $total + $value;
            }
        }
                
        if (count($keywords['required']))
        {
            foreach ($keywords['required'] as $cur1 => $val1)
            {
                $value = $simple_search_values[$cur]+($simple_search_values[$cur] * $link_importanceForRequired_fields/100);
                
                if ($sql_type == "mssql")
                {
                	$ret.= " (CASE WHEN PATINDEX('%$val1%', $val) > 0 THEN $value ELSE 0 END) +";
                }
                else
               		$ret.= " (IF ($val LIKE '%$val1%', ".$value.", 0)) +";
               		
                $total = $total + $value;
            }
        }

		if (count($keywords['notallowed']))
        {
            foreach ($keywords['notallowed'] as $cur1 => $val1)
            {
                $value = $simple_search_values[$cur];
                
                if ($sql_type == "mssql")
                {
                	$ret.= " (CASE WHEN PATINDEX('%$val1%', $val) > 0 THEN 0 ELSE $value END) +";
                }
                else
                	$ret.= " (IF ($val NOT LIKE '%$val1%', ".$value.", 0)) +";
                	
                $total = $total + $value;
            }
        }
    }
    
    $ret = substr($ret, 0, strlen($ret)-2);

	// TOTAL MAXIMUM KEYWORDS RELEVANCE VALUE
    $MaxSearchKeywordsRelevance = $total.".000";
    
    return $ret;   
}

function GetMaxRelevance($phrase)
{
    $simple_search_array = do_search_where();
    $keywords = GetKeywords($phrase);
    
    GetIFStatement($simple_search_array, $keywords);
    
    return $ret;    
}

## Modified in In-link 2.3.3
function do_extended_search($phrase, $cat_id, $search_in_cats)
{	
	global	$admin, $cat_ids, $sid, $conn, $multiple_search_instances, $sql_type, $keywords, $simple_search_array, $SimpleSearchFields, $relavance, $ExtSearchExecuted, $MaxSearchKeywordsRelevance, $sql_type;
	
	$ExtSearchExecuted = 1;
	
	// PARSE AND GET ALL KEYWORDS 
	$phrase = ereg_replace("%","\%",$phrase);
	$phrase = ereg_replace("_","\%",$phrase);
	$keywords = GetKeywords($phrase);

	// GET ALL SEARCH FIELDS
	$simple_search_array = do_search_where();
			
	// CHECK FOR CUSTOMS FIELDs FOR LINKs ARE searchable.
	$AddJoins = "";
	if (in_array("cust1", $simple_search_array) || in_array("cust2", $simple_search_array) || in_array("cust3", $simple_search_array) || in_array("cust4", $simple_search_array) || in_array("cust5", $simple_search_array) || in_array("cust6", $simple_search_array))
	   $AddJoins = "LEFT JOIN inl_custom ON inl_links.link_cust=inl_custom.cust_id LEFT JOIN inl_users ON inl_links.link_user=inl_users.user_id ";

	// Search table definition (depending on SQL type)   
	if ($sql_type == "mssql")
		$SQL_MainCreate = "CREATE TABLE inl_$sid (search_rel DEC (6,4) DEFAULT '0.0000', link_id INT, PRIMARY KEY (link_id))";   
	else
		$SQL_MainCreate = "CREATE TABLE inl_$sid ";
	   
    // GET RELAVANCE
	$IFStatement = getRelevanceFormula($simple_search_array, $keywords);
	$SQL_MainIFStatement = "(".$IFStatement.") AS search_rel, ";
	
	$SQL_MainSelect = " SELECT DISTINCT ".$SQL_MainIFStatement."inl_links.link_id FROM inl_links LEFT JOIN inl_lc ON inl_lc.link_id=inl_links.link_id ".$AddJoins;

	$SQL_SubSelect = "SELECT search_id FROM inl_$sid ";
		
	// CHECK FOR CATEGORY VISIBILITY
	if ($admin)
		$vis = ($search_in_cats != 3)? " AND inl_lc.link_pend='0'" : "";	
	else 
	{
		if ($search_in_cats != 3)
		{
			$SQL_MainSelect.= " LEFT JOIN inl_cats ON inl_cats.cat_id=inl_lc.cat_id";
			$vis = " AND inl_links.link_vis=1 AND inl_lc.link_pend=0 AND (inl_cats.cat_vis=1 OR inl_cats.cat_vis IS NULL) AND ".AddGetExpirationToQuery(time());
		}
	}

	## GET ALL SUB-CATEGORIES FOR FINE SEARCH
	$cat_ids = "";
	
	if ($search_in_cats == 1)
	{
		cat_subs($cat_id);
		$cat_ids = ereg_replace(", $", "", $cat_ids);
		$in = " AND inl_links.link_id=inl_lc.link_id AND inl_lc.cat_id IN ($cat_ids)";
	}
	elseif ($search_in_cats == 2)
		$in = " AND inl_links.link_id=inl_lc.link_id AND inl_lc.cat_id IN ($cat_id)";
	
	// MAKE MAIN WHERE CLAUSE
	$SQL_WHERE_string = NEW_get_where_string($simple_search_array);
		
	// CONSTRUCT AND EXECUTE QUERY
	if ($search_in_cats != 3)
	{
		## Have to create temporarily table first
		if ($sql_type == "mssql")
		{
			$rs = &$conn->Execute($SQL_MainCreate);			
			$query = "INSERT INTO inl_$sid ".$SQL_MainSelect." WHERE ".$SQL_WHERE_string.$in.$vis;
		}
		else
			$query = $SQL_MainCreate.$SQL_MainSelect." WHERE ".$SQL_WHERE_string.$in.$vis;		
		
	}
	else
	{
	    if ($sql_type == "mssql")
	    {
	    	$tempTableName = "#inl_".$sid."_temp";
	    	dropTable($tempTableName);
	    }
	    else
	    {
	    	$tempTableName = "inl_".$sid."_temp";	
	    	$add_temp = "TEMPORARY ";	    	
	    }
	    
		$MainTempTable = str_replace("TABLE inl_".$sid, $add_temp."TABLE ".$tempTableName, $SQL_MainCreate);
        $SQL_MainTempSelect = " SELECT DISTINCT ".$SQL_MainIFStatement." inl_links.link_id FROM inl_".$sid." AS t1 LEFT JOIN inl_links ON t1.link_id=inl_links.link_id ".$AddJoins." WHERE ".$SQL_WHERE_string;        
	    
        if ($sql_type == "mssql")
	    {       	
        	$rs = &$conn->Execute($MainTempTable);
	    	$query1 = "INSERT INTO ".$tempTableName.$SQL_MainTempSelect;	    		    }
	    else
	    	$query1 = $MainTempTable.$SQL_MainTempSelect;    
	    	
	    		
	    $rs = &$conn->Execute($query1); 	
	    
	    //echo ($query1); 
	    // die();
	 	
	    // EMPTY THE ORIGINAL TABLE
	    $sql = "DELETE FROM inl_".$sid;
	    $rs = &$conn->Execute($sql); 
	 	     
	    $query = "INSERT INTO inl_".$sid." SELECT * FROM ".$tempTableName;
		 
	}	
	$rs = &$conn->Execute($query); 
	
	// ADD ALTER AFTER ALL TABLE CREATED
	if ($search_in_cats != 3)
	{
		if ($sql_type == "mssql")
			$sql = "CREATE INDEX search_rel ON inl_".$sid." (search_rel)";
		else 
		{	
			$sql = "ALTER TABLE inl_".$sid." ADD INDEX(search_rel), ADD INDEX(link_id)";			
		}		
	}	
		
    $rs = &$conn->Execute($sql);
	$q = "";
	
	return true;
}

function AdvancedRelavanceCheck($keywords)
{	
	global $conn, $sid;
	
	
	$SQL_1 = "UPDATE inl_$sid SET search_order=2 WHERE ";	

	return $ret;
}

function get_where_string($fld_array, $key, $value1, $value2)
{
	
	foreach($key as $k => $v)
	{
		$q.= "(";
		foreach($fld_array as $fld)
			$q.=" $fld like '%".$v."%' $value1";
		$q.= ") $value2 ";
	}
	return $q;
	
}

function avd_get_keywords($phrase)
{	
	global $field_name, $field_data;

	$t_len = strlen($phrase);
	$ce = 0;
	for ($i=0; $i<$t_len; $i++)
	{	#search for next special tag
		switch ($phrase[$i])
		{
			case "|":
					$field_close = strpos($phrase,":", $i+1);
					$exact_word = substr($phrase, $i+1, ($field_close-$i)-1);
					$i = $field_close;
					
					if ($exact_word)
					{	
						$field_name[$ce] = $exact_word;
					
						$word_close = strpos($phrase,"|", $i+1);
						$exact_word = substr($phrase, $i+1, ($word_close-$i)-1);
						
						
						if ((strlen($exact_word)>0) || ($exact_word=="0"))
						{
					
							$field_data[$ce] = addslashes($exact_word);
						
							if ($field_name[$ce] == "type")
								$i = $t_len;
							else 
							{
								$i = $word_close-1;
								$ce++;
							}
							
						}
					}
				break;
		}
	}
}

function adv_search_parsing($phrase, $link_or_cat, $pend=0)
{	global $field_name, $field_data, $admin, $ses; 
	
	$h = ""; $q = "";
	$vis = "";
	
	avd_get_keywords($phrase);
	$seperator = $field_data[count($field_name)-1];
	foreach ($field_name as $k=>$v)
	{
		switch ($v)
		{
			case "$link_or_cat"."_date1":
			case "$link_or_cat"."_rating1":
			case "$link_or_cat"."_votes1":
			case "$link_or_cat"."_hits1":
				$f = substr($field_name[$k], 0, strlen($field_name[$k])-1);
				if (strlen($h)>1)
					$h.= $seperator." ".$f."<".$field_data[$k]." "; 
				else 
					$h.= $f.">".$field_data[$k]." "; 
				break;
			case "$link_or_cat"."_date2":
			case "$link_or_cat"."_rating2":
			case "$link_or_cat"."_votes2":
			case "$link_or_cat"."_hits2":
				$f = substr($field_name[$k], 0, strlen($field_name[$k])-1);
				if (strlen($h)>1)
					$h.= $seperator." ".$f.">".$field_data[$k]." "; 
				else 
					$h.= $f."<".$field_data[$k]." "; 
				break;	
			case "$link_or_cat"."_pick":
			case "$link_or_cat"."_vis":
				$f = $field_name[$k];
				if (strlen($h)>1)
					$h.= $seperator." ".$f."=".$field_data[$k]." "; 
				else 
					$h.= $f."=".$field_data[$k]." "; 	
				break;	
			case "type":
				break;
			default:
				$f = $field_name[$k];
				if (strlen($h)>1)
					$h.= $seperator." ".$f." like '%".$field_data[$k]."%' "; 
				else 
					$h.= $f." like '%".$field_data[$k]."%' "; 
				break;
		}
	}
	$h = ereg_replace(" $","", $h);
	
	if ($link_or_cat == "link")
	{
		if ($admin==1) 
		{
			if ($pend==1)
			{
				if($ses["user_perm"]==5) // editor
				{		
					$q = "LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id ";
					$vis = " AND inl_cats.cat_user=".$ses["user_id"];
				}
				$vis.= " AND inl_lc.link_pend!=0";
			}
			else
				$vis = " AND inl_lc.link_pend<1";

		}
		else 
		{
			$q = "LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id ";
			$vis = " AND inl_links.link_vis=1 AND inl_lc.link_pend<1 AND (inl_cats.cat_vis=1 OR inl_cats.cat_vis IS NULL)";
		}
	}
	elseif ($link_or_cat == "cat") 
	{
		if ($admin==1)
		{
			if ($pend==1)
			{
				if($ses["user_perm"]==5)
				{
					$sub_cats = pending_cats_in_list_for_editor();
					if ($sub_cats == "")
						$sub_cats = -1;
					$vis = " AND cat_sub IN (".$sub_cats.")";
				}
				$vis.= " AND inl_cats.cat_pend!=0";	
			}
			else
				$vis = " AND inl_cats.cat_pend<1";
		}
		else 
		{
			$vis = " AND inl_cats.cat_vis=1 AND inl_cats.cat_pend<1";
		}
	}

	$h = $q."WHERE (".$h.")".$vis;
	
	return $h;
}

// OLD FUNCTION
function get_keywords($phrase)
{	global $conn;
	$t_len = strlen($phrase);
	$ce=0;
	for ($i=0; $i<$t_len; $i++)
	{	#search for next special tag
		switch ($phrase[$i])
		{
			/*case "'":
					$exact_match_close = strpos($phrase,"'", $i+1);
					if(!$exact_match_close)
						break;
					$exact_word=substr($phrase, $i+1, ($exact_match_close-$i)-1);
					$i=$exact_match_close;
					if($exact_word)
					{	$w_array[$ce]=$exact_word;
						$ce++;
						$exact_word="";
					}	
					break;*/
			case "\"":
					$exact_match_close = strpos($phrase,"\"", $i+1);
					if(!$exact_match_close)
						break;
					$exact_word=substr($phrase, $i+1, ($exact_match_close-$i)-1);
					$i=$exact_match_close;
					if($exact_word)
					{	$w_array[$ce]=addslashes($exact_word);
						$ce++;
						$exact_word="";
					}
					break;
					
			case "+":
			case " ":
			case ",":
				if($exact_word)
				{	
					
					$w_array[$ce]=addslashes($exact_word);
					$ce++;
					$exact_word="";
					
				}
				break;

			default:
				$exact_word.=$phrase[$i];
		}
	}

	// ONLY ONE SEARCH TERM WAS ENTERED
	if($exact_word)
		$w_array[$ce]=addslashes($exact_word);

	
	$query="Select * from inl_keywords order by keyword asc";
	$rs=&$conn->Execute($query);
	while ($rs && !$rs->EOF)
	{	$key_data = $rs->fields;
		for($i=0;$i<count($w_array);$i++)
			if(strtolower($key_data["keyword"])==strtolower($w_array[$i]))
				unset($w_array[$i]);
		$rs->MoveNext();
	}
	
	return $w_array;
}
// END OLD GET KEYWORDS




function cat_subs($c)
{	global $conn, $cat_ids;
	
	$sql = "SELECT cat_id FROM inl_cats WHERE cat_sub=$c";
	$rs = &$conn->Execute($sql);
	$cat_ids.= $c.", ";
	while ($rs && !$rs->EOF)
	{
		$i = $rs->fields[0];
		cat_subs($i);
		$rs->MoveNext();
	}
}		

function do_simple_search($phrase, $cat_id, $search_in_cats)
{	
	global $cat_ids, $sid, $admin, $multiple_search_instances, $sql_type;
	
	$phrase = ereg_replace("%","\%",$phrase);
	$phrase = ereg_replace("_","\_",$phrase);
	$in = "";
	$cat_ids = "";
		
	if ($admin == 1)
		$vis = "";
	else 
	{
		$q = "LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id";
		$vis = " AND inl_links.link_vis=1 AND inl_lc.link_pend=0 AND (inl_cats.cat_vis=1 OR inl_cats.cat_vis IS NULL)";
	}
	
	if ($search_in_cats == 1)
	{
		cat_subs($cat_id);
		$cat_ids = ereg_replace(", $", "", $cat_ids);
		$in = " AND inl_links.link_id=inl_lc.link_id AND inl_lc.cat_id IN ($cat_ids)";
	}
	elseif ($search_in_cats == 2)
		$in = " AND inl_links.link_id=inl_lc.link_id AND inl_lc.cat_id IN ($cat_id)";
	
	$w_array = get_keywords($phrase);//GetKeywords($phrase); //
	$simple_search_array = do_search_where();
	$string = get_where_string($simple_search_array, $w_array, "OR", "OR");
	$string = ereg_replace("OR)",")", $string);
	$string = ereg_replace(" OR $","", $string);
	
	$q.= " WHERE (".$string.")".$in.$vis;
	return $q;

}

function searchforlinks($word, $cat)
{	
	global $conn, $table;
	
	if (!get_magic_quotes_gpc())
		$word = addslashes($word);

	settype($cat, "integer");
	$t = time();
	$word = trim($word);

	$a = 0;
	
	if (($table=="link1") || ($table=="link2") || ($table=="link3"))
		$a = substr($table, strlen($table)-1, 1);
	
	$SQL = "INSERT inl_search_log (log_type, log_date, log_search, search_action, log_keyword, search_cat) VALUES (2, $t, 1, $a, '$word', $cat)";
	
	$conn->Execute($SQL);
	return $conn->Insert_ID("inl_search_log","log_id");
}	

function searchforcats($word)
{
	global $conn;
	$t=time();
	if (!get_magic_quotes_gpc())
		$word = addslashes($word);
	$word=trim($word);
	$word=ereg_replace("[[:space:]]*(\+)[[:space:]]*","+",$word);
	
	if ($table=="cat1")
		$a = 1;
	else 
		$a = 0;

	$SQL = "insert into inl_search_log (log_type, log_date, log_search, log_keyword, search_action) values (1, $t, 1, '$word', $a)";
	$conn->Execute($SQL);
	return $conn->Insert_ID("inl_search_log","log_id");
}	

function getadvcatsearch()
{	
    global $conn,
	$form_input_search_cat_name, $form_input_search_cat_desc, $form_input_search_cat_fday, $form_input_search_cat_fmonth, $form_input_search_cat_fyear, $form_input_search_cat_lday, $form_input_search_cat_lmonth, $form_input_search_cat_lyear, $form_radio_search_cat_pick, $form_input_search_sep, $form_input_search_cat_ccust1, $form_input_search_cat_ccust2, $form_input_search_cat_ccust3, $form_input_search_cat_ccust4, $form_input_search_cat_ccust5, $form_input_search_cat_ccust6;

	$cat_name=search_escape(inl_escape($form_input_search_cat_name));
	$cat_desc=search_escape(inl_escape($form_input_search_cat_desc));
	$fday=search_escape(inl_escape($form_input_search_cat_fday));
	$fmonth=search_escape(inl_escape($form_input_search_cat_fmonth));
	$fyear=search_escape(inl_escape($form_input_search_cat_fyear));
	$lday=search_escape(inl_escape($form_input_search_cat_lday));
	$lmonth=search_escape(inl_escape($form_input_search_cat_lmonth));
	$lyear=search_escape(inl_escape($form_input_search_cat_lyear));
	$sep=search_escape(inl_escape($form_input_search_sep));
	$cat_pick=search_escape(inl_escape($form_radio_search_cat_pick));
	$ccust1=search_escape(inl_escape($form_input_search_cat_ccust1));
	$ccust2=search_escape(inl_escape($form_input_search_cat_ccust2));
	$ccust3=search_escape(inl_escape($form_input_search_cat_ccust3));
	$ccust4=search_escape(inl_escape($form_input_search_cat_ccust4));
	$ccust5=search_escape(inl_escape($form_input_search_cat_ccust5));
	$ccust6=search_escape(inl_escape($form_input_search_cat_ccust6));
	$log="";
	if (strlen($cat_name) > 0)
		$log.= "|cat_name:$cat_name";
	if (strlen($cat_desc) > 0)
		$log.= "|cat_desc:$cat_desc";
	if	($fday>0 && $fday<32 && $fmonth>0 && $fmonth<13 && $fyear>1900 && $fyear<4000)
		$log.= "|cat_date2:".mktime(0,0,0,$fmonth,$fday,$fyear);
	if	($lday>0 && $lday<32 && $lmonth>0 && $lmonth<13 && $lyear>1900 && $lyear<4000)
		$log.= "|cat_date1:".mktime(0,0,0,$lmonth,$lday,$lyear);
	if (strlen($cat_pick) > 0)
		$log.= "|cat_pick:$cat_pick";
	if (strlen($ccust1) > 0)
		$log.= "|cust1:$ccust1";
	if (strlen($ccust2) > 0)
		$log.= "|cust2:$ccust2";
	if (strlen($ccust3) > 0)
		$log.= "|cust3:$ccust3";
	if (strlen($ccust4) > 0)
		$log.= "|cust4:$ccust4";
	if (strlen($ccust5) > 0)
		$log.= "|cust5:$ccust5";
	if (strlen($ccust6) > 0)
		$log.= "|cust6:$ccust6";
	if (strlen($log) > 0)
		$log.= "|type:$sep|";
	
	if ($log == "")
	{
		$message = base64_encode("Please enter at least 1 keyword for search");
		$destin = "index.php?t=error&message=$message";
		inl_header($destin);	
	}

	$t = time();
	$SQL="INSERT INTO inl_search_log (log_type, log_date, log_search, log_keyword) values (1, $t, 2, ".$conn->qstr($log).")";
	$conn->Execute($SQL);
	return $conn->Insert_ID("inl_search_log","log_id");
}

function getadvlinksearch()
{	
    global $conn,
	$form_input_search_link_name, $form_input_search_link_desc,    $form_input_search_link_fdayl, $form_input_search_link_fmonthl, $form_input_search_link_fyearl,  $form_input_search_link_ldayl, $form_input_search_link_lmonthl, $form_input_search_link_lyearl, $form_input_search_link_rating_l, $form_input_search_link_rating_f, $form_input_search_link_votes_l, $form_input_search_link_votes_f, $form_input_search_link_hits_l, $form_input_search_link_hits_f,   $form_radio_search_link_pick,   $form_input_search_link_lcust1, $form_input_search_link_lcust2, $form_input_search_link_lcust3, $form_input_search_link_lcust4, $form_input_search_link_lcust5,  $form_input_search_link_lcust6,
	$form_input_search_sep;

	$link_name=search_escape(inl_escape($form_input_search_link_name));
	$link_desc=search_escape(inl_escape($form_input_search_link_desc));
	$fday=search_escape(inl_escape($form_input_search_link_fdayl));
	$fmonth=search_escape(inl_escape($form_input_search_link_fmonthl));
	$fyear=search_escape(inl_escape($form_input_search_link_fyearl));
	$lyear=search_escape(inl_escape($form_input_search_link_lyearl));
	$lday=search_escape(inl_escape($form_input_search_link_ldayl));
	$lmonth=search_escape(inl_escape($form_input_search_link_lmonthl));
	$link_rating_l=search_escape(inl_escape($form_input_search_link_rating_l));
	$link_rating_f=search_escape(inl_escape($form_input_search_link_rating_f));
	$link_votes_l=search_escape(inl_escape($form_input_search_link_votes_l));
	$link_votes_f=search_escape(inl_escape($form_input_search_link_votes_f));
	$link_hits_l=search_escape(inl_escape($form_input_search_link_hits_l));
	$link_hits_f=search_escape(inl_escape($form_input_search_link_hits_f));
	$link_pick=search_escape(inl_escape($form_radio_search_link_pick));
	$sep=search_escape(inl_escape($form_input_search_sep));
	$lcust1=search_escape(inl_escape($form_input_search_link_lcust1));
	$lcust2=search_escape(inl_escape($form_input_search_link_lcust2));
	$lcust3=search_escape(inl_escape($form_input_search_link_lcust3));
	$lcust4=search_escape(inl_escape($form_input_search_link_lcust4));
	$lcust5=search_escape(inl_escape($form_input_search_link_lcust5));
	$lcust6=search_escape(inl_escape($form_input_search_link_lcust6));
	
	$log="";
	if (strlen($link_name) > 0)
		$log.= "|link_name:$link_name";
	if (strlen($link_desc) > 0)
		$log.= "|link_desc:$link_desc";
	if	($fday>0 && $fday<32 && $fmonth>0 && $fmonth<13 && $fyear>1900 && $fyear<4000)
		$log.= "|link_date2:".mktime(0,0,0,$fmonth,$fday,$fyear);
	if	($lday>0 && $lday<32 && $lmonth>0 && $lmonth<13 && $lyear>1900 && $lyear<4000)
		$log.= "|link_date1:".mktime(0,0,0,$lmonth,$lday,$lyear);
	if (strlen($link_rating_l) > 0)
		$log.= "|link_rating1:$link_rating_l";
	if (strlen($link_rating_f) > 0)
		$log.= "|link_rating2:$link_rating_f";
	if (strlen($link_votes_l) > 0)
		$log.= "|link_votes1:$link_votes_l";
	if (strlen($link_votes_f) > 0)
		$log.= "|link_votes2:$link_votes_f";
	if (strlen($link_hits_l) > 0)
		$log.= "|link_hits1:$link_hits_l";
	if (strlen($link_hits_f) > 0)
		$log.= "|link_hits2:$link_hits_f";
	if (strlen($link_pick) > 0)
		$log.= "|link_pick:$link_pick";
	if (strlen($lcust1) > 0)
		$log.= "|cust1:$lcust1";
	if (strlen($lcust2) > 0)
		$log.= "|cust2:$lcust2";
	if (strlen($lcust3) > 0)
		$log.= "|cust3:$lcust3";
	if (strlen($lcust4) > 0)
		$log.= "|cust4:$lcust4";
	if (strlen($lcust5) > 0)
		$log.= "|cust5:$lcust5";
	if (strlen($lcust6) > 0)
		$log.= "|cust6:$lcust6";
	if (strlen($log) > 0)
		$log.= "|type:$sep|";

	if ($log == "")	
	{
		$message = base64_encode("Please enter at least 1 keyword for search");
		$destin = "index.php?t=error&message=$message";
		inl_header($destin);	
	}

	$t = time();
	$SQL="INSERT INTO inl_search_log (log_type, log_date, log_search, log_keyword) values (2, $t, 2, ".$conn->qstr($log).")";
	$conn->Execute($SQL);
	return $conn->Insert_ID("inl_search_log","log_id");
}

function GetKeywords($phrase)
{  
	global $KeywordIgnore;
    
    if(count($KeywordIgnore)==0)
       GetIgnoreList();
    $keywords["normal"]= array();
    $keywords["required"]= array();
    $keywords["notallowed"] = array();
    $keywords["ignored"] = array();  
    if(!strlen($phrase))
        return $keywords;
    $w_array = array();
    $phrase = trim($phrase);
	
    $t_len = strlen($phrase);
	$ce=0;
	for ($i=0; $i<$t_len; $i++)
	{	#search for next special tag
		switch ($phrase[$i])
		{
			case "\"":
					$exact_match_close = strpos($phrase,"\"", $i+1);
					if(!$exact_match_close)
						break;
					$exact_word=substr($phrase, $i+1, ($exact_match_close-$i)-1);
					$i=$exact_match_close;
					if($exact_word)
					{	
                        if(strlen($token)==0)
                            $token="|";
                        $w_array[$ce]=$token.addslashes($exact_word);						
                        $token="";
                        $ce++;
						$exact_word="";
					}
					break;
					
            case "+":
                if(strlen($exact_word)==0)
                {                
                  $token = "+";
                }
                else
                    $exact_word .= "+";
				break;
            case "-":
                if(strlen($exact_word)==0)
                {                
				  $token = "-";
                }
                else
                    $exact_word .="-";
                break;
			case " ":
			case ",":
				if($exact_word)
				{	                
                  if(strlen($token)==0)
                    $token="|";
                  if($token=="|")
                  {
                      if($KeywordIgnore[strtolower($exact_word)]==1)
                      {
                          $w_array[$ce]= "=".addslashes($exact_word);
                          $ce++;
                      }
                      else
                      {                      
                        $w_array[$ce]=$token.addslashes($exact_word);
                        $ce++;
                      }
                  }
                  else
                  {
                    $w_array[$ce]=$token.addslashes($exact_word);
                    $ce++;
                  }
                  $token="";
				  $exact_word="";				
				}
				break;

			default:
				$exact_word.=$phrase[$i];
		}
	}
	if($exact_word)
    {
      if(strlen($token)==0)
          $token="|";
      if($KeywordIgnore[strtolower($exact_word)]==1 && ($token =="|" || $token=="="))
      {
          $w_array[$ce]= "=".addslashes($exact_word);
          $ce++;
      }
      else
      {                      
        $w_array[$ce]=$token.addslashes($exact_word);
        $ce++;
      }
    }
  for ($i=0;$i<count($w_array);$i++) 
  {
      $keyword = $w_array[$i];
      switch(substr($keyword,0,1))
      {
        case "|":
           $keywords["normal"][]=substr($keyword,1);
		
           break;
        case "+":
           $keywords["required"][] = substr($keyword,1);
		
           break;
        case "-":
           $keywords["notallowed"][] = substr($keyword,1);
	
           break;
        case "=":
           $keywords["ignored"][] = substr($keyword,1);
	
           break;
      }
  }
  $i = 0;
  
  return($keywords);
}

function GetIgnoreList()
{ 
	global $conn, $KeywordIgnore;

	$query="SELECT * FROM inl_keywords ORDER BY keyword ASC";
	$rs=&$conn->Execute($query);
	while ($rs && !$rs->EOF)
	{	
		$KeywordIgnore[$rs->fields['keyword']] = 1;
		$rs->MoveNext();
	}
}

function AddSearchField($keywords, $_type)
{ 
	global $simple_search_array;
	      
	$w = "";
  
    if(count($keywords)>0)
    {          
       if ($_type == "required") 
		{
			$or_inner1 = " OR ";
			$or_inner2 = ") AND ";
			$operator = "LIKE";

		}
		elseif ($_type == "normal") 
		{
			$or_inner1 = " OR ";
			$or_inner2 = ") OR ";
			$operator = "LIKE";
		}
		elseif ($_type == "notallowed")
		{
			$or_inner1 = " AND ";
			$or_inner2 = ") AND ";
			$operator = "NOT LIKE";
		}
	   
			for($i=0;$i<count($keywords);$i++)
			{ 
					
					$w.= " (";
					 for($j=0;$j<count($simple_search_array);$j++)
					 {
							if (strlen($keywords[$i])>0) 
							{             
								if($j>0)
								{              
									 $or = $or_inner1;
								 }
								else
									  $or = "";
								 $w.= "$or(".$simple_search_array[$j]." ".$operator." '%".$keywords[$i]."%')";

							}
					 }		

					if($i<count($keywords)-1)
					{              
						 $or = $or_inner2;
					}
					else
						  $or = ") ";
					$w.= $or;	
			}
		$ret = $w;
	}

	if(strlen($w)>0)
    {            
		$where = "(".$w.")";
		$where = $w;
    }
	else
		$where = "";
			
	$ret = $where;	
	return $ret;
}

function NEW_get_where_string($fld_array)
{ 
	global $keywords;
	
	$q = "( ";
	$list = array("normal", "required", "notallowed");
	
	foreach ($list as $val)
	{
		if (count($keywords[$val])>0)
		{
			$ret = AddSearchField($keywords[$val], $val);
			$q.= "(".$ret.") AND ";
		}
	}
     
	
	$q = eregi_replace(" AND $", "", $q);
	$q.= " )";

	return $q;
}
?>